(function() {
var GridSortOrder = { None: 0, Ascending: 1, Descending: 2 };
var ASPxClientGridColumnMovingTargetPosition = {
 Right: 0,
 Left: 1,
 Top: 2,
 Bottom: 3
};
var ASPxClientGridBase = ASPx.CreateClass(ASPxClientControl, {
 MainTableID: "DXMainTable",
 CustomizationWindowSuffix: "_custwindow",
 EditingRowID: "_DXEditingRow",
 EditingErrorItemID: "DXEditingErrorItem", 
 EmptyHeaderSuffix: "_emptyheader",
 PagerBottomID: "DXPagerBottom",
 PagerTopID: "DXPagerTop",
 SearchEditorID: "DXSE",
 SelectButtonID: "DXSelBtn",
 HeaderFilterButtonClassName: "dxgv__hfb",
 CommandColumnItemClassName: "dxgv__cci",
 DetailGridSuffix: "dxdt",
 FixedColumnsDivID: "DXFixedColumnsDiv",
 FixedColumnsContentDivID: "DXFixedColumnsContentDiv",
 ProgressBarDisplayControlIDFormat: "PBc{0}i{1}",
 AccessibleFilterRowButtonID: "AFRB",
 RequireKeyFieldNameText: "Error while trying to perform a CRUD operation with an incorrect or unspecified KeyFieldName property value.",
 EtalonBatchRecordPostFix: "dxgbeEtalonRecord",
 InvalidItemIndex: -23061988,
 constructor: function(name){
  this.constructor.prototype.constructor.call(this, name);
  this.callBacksEnabled = true;
  this.custwindowLeft = null;
  this.custwindowTop = null;
  this.custwindowVisible = null;
  this.userChangedSelection = false;
  this.confirmDelete = "";
  this.editorIDList = [ ];
  this.keys = [ ];
  this.lastMultiSelectIndex = -1;
  this.mainTableClickData = {
   processing: false,
   focusChanged: false,
   selectionChanged: false
  };
  this.afterCallbackRequired = false;
  this.enableHeaderFilterCaching = true;
  this.supportGestures = true;
  this.checkBoxImageProperties = null;
  this.internalCheckBoxCollection = null;
  this.sizingConfig.adjustControl = true;
  this.lookupBehavior = false;
  this.isAccessibleRowEditing = false;
  this.batchEditApi = this.CreateBatchEditApi();
  this.CustomButtonClick = new ASPxClientEvent();
  this.SelectionChanged = new ASPxClientEvent();
  this.ColumnSorting = new ASPxClientEvent();
  this.ColumnGrouping = new ASPxClientEvent();
  this.CustomizationWindowCloseUp = new ASPxClientEvent();
  this.InternalCheckBoxClick = new ASPxClientEvent();
  this.BatchEditStartEditing = new ASPxClientEvent();
  this.BatchEditEndEditing = new ASPxClientEvent();
  this.BatchEditConfirmShowing = new ASPxClientEvent();
  this.BatchEditTemplateCellFocused = new ASPxClientEvent();
  this.BatchEditChangesSaving = new ASPxClientEvent();
  this.BatchEditChangesCanceling = new ASPxClientEvent();
  this.FocusedCellChanging = new ASPxClientEvent();
  this.ToolbarItemClick = new ASPxClientEvent();
  this.pendingCommands = [ ];
  this.pageRowCount = 0;
  this.pageRowSize = 0;
  this.pageIndex = 0;
  this.pageCount = 1;
  this.allowDelete = false;
  this.allowEdit = false;
  this.allowInsert = false;
  this.allowFocusedRow = false;
  this.allowFocusedCell = false;
  this.allowSelectByItemClick = false;
  this.allowSelectSingleRowOnly = false;
  this.allowMultiColumnAutoFilter = false;
  this.focusedRowIndex = -1;
  this.selectedWithoutPageRowCount = 0;
  this.selectAllSettings = [ ];
  this.selectAllBtnStateWithoutPage = null;
  this.visibleStartIndex = 0;
  this.columns = [ ];
  this.columnResizeMode = ASPx.ColumnResizeMode.None;
  this.horzScroll = ASPx.ScrollBarMode.Hidden;
  this.vertScroll = ASPx.ScrollBarMode.Hidden;
  this.scrollToRowIndex = -1;
  this.useEndlessPaging = false;
  this.allowBatchEditing = false;
  this.batchEditClientState = { };
  this.resetScrollTop = false;
  this.callbackOnFocusedRowChanged = false;
  this.callbackOnSelectionChanged = false;
  this.autoFilterDelay = 1200;
  this.searchFilterDelay = 1200;
  this.allowSearchFilterTimer = true;
  this.editState = 0;
  this.kbdHelper = null;
  this.enableKeyboard = false;
  this.keyboardLock = false;
  this.accessKey = null;
  this.customKbdHelperName = null;
  this.endlessPagingHelper = null;
  this.toolbarHelper = null;
  this.icbFocusedStyle = null;
  this.pendingEvents = [ ];
  this.customSearchPanelEditorID = null;
  this.searchPanelFilter = null;
  this.isDetailGrid = null;
  this.rowHotTrackStyle = null;
  this.updateButtonName = "";
  this.cancelButtonName = "";
  this.isAccessibleFilterRowMenu = false;
  this.userHandledCallbackError = false;
 },
 HasHorzScroll: function() { return this.horzScroll != ASPx.ScrollBarMode.Hidden; },
 HasVertScroll: function() { return this.vertScroll != ASPx.ScrollBarMode.Hidden; },
 HasScrolling: function() { return this.HasHorzScroll() || this.HasVertScroll(); },
 AllowResizing: function() { return this.columnResizeMode != ASPx.ColumnResizeMode.None; },
 GetGridTD: function() { 
  var table = this.GetMainElement();
  if(!table) return null;
  return table.rows[0].cells[0];
 },
 GetArrowDragDownImage: function() { return this.GetChildElement("IADD"); },
 GetArrowDragUpImage: function() { return this.GetChildElement("IADU"); },
 GetArrowDragLeftImage: function() { return this.GetChildElement("IADL"); },
 GetArrowDragRightImage: function() { return this.GetChildElement("IADR"); },
 GetArrowDragFieldImage: function() { return this.GetChildElement("IDHF"); },
 GetEndlessPagingUpdatableContainer: function() { return this.GetChildElement("DXEPUC"); },
 GetEndlessPagingLPContainer: function() { return this.GetChildElement("DXEPLPC"); },
 GetBatchEditorsContainer: function() { return this.GetChildElement("DXBEsC"); },
 GetBatchEditorContainer: function(columnIndex) { return this.GetChildElement("DXBEC" + columnIndex); }, 
 GetLoadingPanelDiv: function() {  return this.GetChildElement("LPD"); },
 GetFixedColumnsDiv: function() {  return this.GetChildElement(this.FixedColumnsDivID); },
 GettItem: function(visibleIndex) { return null; },
 GetDataItemIDPrefix: function() { },
 GetEmptyDataItemIDPostfix: function() { },
 GetEmptyDataItem: function() { return this.GetChildElement(this.GetEmptyDataItemIDPostfix()); },
 GetDataRowSelBtnIDPrefix: function() { return "_" + this.SelectButtonID; },
 GetDataRowSelBtn: function(index) { return this.FindSelectButton(this.GetItem(index), this.GetDataRowSelBtnIDPrefix(index)); },
 FindSelectButton: function(container, idPrefix) { return container && container.querySelector("input[id^='" + this.name + idPrefix + "']"); },
 GetSelectAllBtn: function(index) { return this.GetChildElement("DXSelAllBtn" + index); },
 GetMainTable: function() { return this.GetChildElement(this.MainTableID); },
 GetLoadingPanelContainer: function() { return this.GetChildElement("DXLPContainer"); },
 GetGroupPanel: function() { return this.GetChildElement("grouppanel"); },
 GetHeader: function(columnIndex, inGroupPanel) { 
  var id = "col" + columnIndex;
  if(inGroupPanel)
   id = "group" + id;
  return this.GetChildElement(id); 
 },
 GetHeaderRow: function(index) {
  return ASPx.GetElementById(this.name + "_" + ASPx.GridViewConsts.HeaderRowID + index);
 },
 GetEditingRow: function(obj) { return ASPx.GetElementById((obj ? obj.name : this.name) + this.EditingRowID); },
 GetEditingErrorItem: function(obj) { return ASPx.GetElementById((obj ? obj.name : this.name) + "_" + this.EditingErrorItemID); },
 GetEditFormTable: function() { return ASPx.GetElementById(this.name + "_DXEFT"); },
 GetCustomizationWindow: function() { return ASPx.GetControlCollection().Get(this.name + this.CustomizationWindowSuffix); },
 GetCustomizationWindowElement: function() {
  var win = this.GetCustomizationWindow();
  return win ? win.GetWindowElement(-1) : null;  
 },
 GetParentRowsWindow: function() { return ASPx.GetControlCollection().Get(this.name + "_DXparentrowswindow"); },
 GetEditorPrefix: function() { return "DXEditor"; },
 GetPopupEditForm: function() { return ASPx.GetControlCollection().Get(this.name  + "_DXPEForm"); },
 GetFilterRowMenu: function() { return ASPx.GetControlCollection().Get(this.name + "_DXFilterRowMenu"); },
 GetFilterRow: function() { return ASPx.GetControlCollection().Get(this.name + "_DXFilterRow"); },
 GetFilterControlPopup: function() { return ASPx.GetControlCollection().Get(this.name + "_DXPFCForm"); },
 GetFilterControl: function() { return ASPx.GetControlCollection().Get(this.name +  "_DXPFCForm_DXPFC"); }, 
 GetHeaderFilterPopup: function() { return ASPx.GetControlCollection().Get(this.name + "_DXHFP"); },
 GetToolbarByName: function(name){
  return this.GetToolbarHelper().GetToolbarByName(name);
 },
 GetToolbar: function(index){
  return ASPx.GetControlCollection().Get(this.name + "_DXCTMenu" + index);
 },
 IsBatchEditDeletedItem: function(visibleIndex) {
  var helper = this.GetBatchEditHelper();
  return helper && helper.IsDeletedRecord(this.ConvertVisibleIndexToKey(visibleIndex));
 },
 IsEmptyHeaderID: function(id) { return false; },
 IsDataItem: function(visibleIndex) { return !!this.GetItem(visibleIndex); },
 GetSearchEditor: function() { 
  var editor = this.GetCustomSearchPanelEditor() || this.GetGridSearchEditor();
  if(editor && editor.GetMainElement())
   return editor;
  return null;
 },
 GetGridSearchEditor: function() { return ASPx.GetControlCollection().Get(this.name + "_" + this.SearchEditorID); },
 GetCustomSearchPanelEditor: function() { return ASPx.GetControlCollection().Get(this.customSearchPanelEditorID); },
 SetSearchPanelCustomEditor: function(editor) { this.GetFilterHelper().SetSearchPanelCustomEditor(editor); },
 GetEditorByColumnIndex: function(colIndex) {
  var list = this._getEditors();
  for(var i = 0; i < list.length; i++) {
   if(this.tryGetNumberFromEndOfString(list[i].name).value === colIndex)
    return list[i];
  }
  return null;
 },
 GetProgressBarControlID: function(visibleIndex, columnIndex) { return ASPx.Str.ApplyReplacement(this.ProgressBarDisplayControlIDFormat, [["{0}", columnIndex], ["{1}", visibleIndex]]); },
 GetProgressBarControl: function(visibleIndex, columnIndex) { return ASPx.GetControlCollection().Get(this.name + "_" + this.GetProgressBarControlID(visibleIndex, columnIndex)); },
 CreateBatchEditApi: function() { },
 SetProperties: function(properties, obj) {
  ASPxClientControl.prototype.SetProperties.call(this, properties, obj);
  this.CreateColumns();
  this.CreateToolbars();
 },
 CreateColumns: function() {
  this.columns = [ ];
  for(var i = 0; i < this.columnProp.length; i++)
   this.columns.push(this.CreateColumn(this.columnProp[i]));
 },
 CreateToolbars: function(){
  this.toolbars = [ ];
  for(var i = 0; this.toolbarsProp && i < this.toolbarsProp.length; i++){
   var toolbarInfo = { index: this.toolbarsProp[i][0], name: this.toolbarsProp[i][1] };
   if(this.GetToolbar(toolbarInfo.index))
    this.toolbars.push(toolbarInfo);
  }
 },
 CreateColumn: function(prop) { },
 IsFilterLocked: function() { return this.GetFilterHelper().IsFilterLocked(); },
 LockFilter: function() { this.GetFilterHelper().LockFilter(); },
 UnlockFilter: function() { this.GetFilterHelper().UnlockFilter(); },
 Initialize: function() {
  ASPxClientControl.prototype.Initialize.call(this);
  this.GetFilterHelper().OnInit();
  this.GetToolbarHelper().OnInit();
  if(this.enabled)
   this.SetHeadersClientEvents();
  this.EnsureRowKeys();
  this._setFocusedItemInputValue();
  this.AddSelectStartHandler();
  if(this.isAccessibleFilterRowMenu)
   this.AddKeyDownFilterRowButtonHandler();
  this.EnsureRowHotTrackItems();
  if(this.checkBoxImageProperties){
   this.CreateInternalCheckBoxCollection();
   this.UpdateSelectAllCheckboxesState();
  }
  this.CheckPendingEvents();
  this.CheckEndlessPagingLoadNextPage();
  this.PrepareCommandButtons();
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   batchEditHelper.Init();
  var cellFocusHelper = this.GetCellFocusHelper();
  if(cellFocusHelper)
   cellFocusHelper.Update();
  window.setTimeout(function() { this.EnsureVisibleRowFromServer(); }.aspxBind(this), 0);
 },
 AttachEventToEditor: function(columnIndex, eventName, handler) {
  var editor = this.GetEditorByColumnIndex(columnIndex);
  if(!ASPx.Ident.IsASPxClientEdit(editor))
   return;
  var attachKeyDownToInput = eventName === "KeyDown" && this.IsCheckEditor(editor);
  if(!editor[eventName] && !attachKeyDownToInput)
   return;
  var duplicateAttachLocker = "dxgv" + eventName + "Assigned";
  if(editor[duplicateAttachLocker]) 
   return;
  if(attachKeyDownToInput)
   ASPx.Evt.AttachEventToElement(editor.GetFocusableInputElement(), "keydown", function(e) { handler(editor, { htmlEvent: e }); });
  else
   editor[eventName].AddHandler(handler);
  editor.dxgvColumnIndex = columnIndex;
  editor[duplicateAttachLocker] = true;
 },
 IsCheckEditor: function(editor) {
  return ASPx.Ident.IsASPxClientCheckEdit && ASPx.Ident.IsASPxClientCheckEdit(editor);
 },
 IsStaticBinaryImageEditor: function(editor) {
  return ASPx.Ident.IsStaticASPxClientBinaryImage && ASPx.Ident.IsStaticASPxClientBinaryImage(editor);
 },
 IsDetailGrid: function() { 
  if(this.isDetailGrid !== null)
   return this.isDetailGrid;
  var regTest = new RegExp(this.DetailGridSuffix + "[0-9]");
  this.isDetailGrid = regTest.test(this.name);
  if(this.isDetailGrid)
   return true;
  var mainElement = this.GetMainElement();
  var parent = mainElement.parentNode;
  while(parent && parent.tagName !== "BODY") {
   this.isDetailGrid = regTest.test(parent.id);
   if(this.isDetailGrid) return true;
   parent = parent.parentNode;
  }
  return false;
 },
 PrepareCommandButtons: function(){
  if(!this.cButtonIDs || this.cButtonIDs.length == 0) return;
  for(var i = 0; i < this.cButtonIDs.length; i++){
   var name = this.cButtonIDs[i];
   var element = ASPx.GetElementById(name);
   if(!element) continue;
   var button = new ASPxClientButton(name);
   element.cpGVCommandButtonInitialized = true;
   button.cpGVName = this.name;
   button.useSubmitBehavior = false;
   button.causesValidation = false;
   button.isNative = !!eval(ASPx.Attr.GetAttribute(button.GetMainElement(), "data-isNative"));
   button.encodeHtml = !!eval(ASPx.Attr.GetAttribute(button.GetMainElement(), "data-encodeHtml"));
   button.enabled = !ASPx.ElementContainsCssClass(button.GetMainElement(), "dxbDisabled");
   button.accessibilityCompliant = this.accessibilityCompliant;
   button.Click.AddHandler(this.OnCommandButtonClick.aspxBind(this));
   button.InlineInitialize();
   this.PrepareCommandButton(button);
  }
  delete this.cButtonIDs;
 },
 PrepareCommandButton: function(button) {  
  if(this.allowBatchEditing && ASPx.GetIsParent(this.GetChildElement("DXStatus"), button.GetMainElement())) { 
   this.EnsureCommandButtonClickArgs(button);
   var commandName = button.gvClickArgs && button.gvClickArgs[0][0];
   if(commandName === "UpdateEdit")
    this.updateButtonName = button.name;
   if(commandName === "CancelEdit")
    this.cancelButtonName = button.name;
   if(commandName === "PreviewChanges")
    this.previewChangesButtonName = button.name;
   if(commandName === "HidePreview")
    this.hidePreviewButtonName = button.name;
  }
 },
 GetBatchEditCommandButtons: function() {
  var buttons = { };
  buttons.updateButton = ASPx.GetControlCollection().Get(this.updateButtonName);
  buttons.cancelButton = ASPx.GetControlCollection().Get(this.cancelButtonName);
  buttons.previewChangesButton = ASPx.GetControlCollection().Get(this.previewChangesButtonName);
  buttons.hidePreviewButton = ASPx.GetControlCollection().Get(this.hidePreviewButtonName);
  return buttons;
 },
 PrepareCommandButtonsIDList: function(container) {
  if(!this.cButtonIDs)
   this.cButtonIDs = [ ];
  var initButtonIndex = this.GetLastCommandButtonIndex() + 1;
  var elementList = container.getElementsByTagName("*");
  for(var i = 0; i < elementList.length; i++) {
   var element = elementList[i];
   var comandButtonIDPattern = /%DXItemIndex\d+%$/g; 
   if(element.id && comandButtonIDPattern.test(element.id)) {
    var patternID = element.id;
    var buttonID = patternID.replace(comandButtonIDPattern, initButtonIndex++);
    ASPx.SetInnerHtml(element.parentNode, element.parentNode.innerHTML.replace(new RegExp(patternID, "g"), buttonID));
    this.cButtonIDs.push(buttonID);
   }
  }
 },
 GetLastCommandButtonIndex: function() {
  var index = -1;
  var disposedControls = [];
  ASPx.GetControlCollection().ForEachControl(function(control) {
   if(control.cpGVName !== this.name)
    return;
   if(!control.GetMainElement()) { 
    disposedControls.push(control);
    return;
   }
   var matches = control.name.match(/_DXCBtn(\d+)/);
   if(matches && matches.length > 1) {
    var buttonIndex = parseInt(matches[1]);
    index = Math.max(index, buttonIndex);
   }
  }, this);
  for(var i = 0; i < disposedControls.length; i++)
   ASPx.GetControlCollection().Remove(disposedControls[i]);
  return index;
 },
 EnsureCommandButtonClickArgs: function(button) {
  if(!button.gvClickArgs)
   button.gvClickArgs = eval(ASPx.Attr.GetAttribute(button.GetMainElement(), "data-args"));
 },
 OnCommandButtonClick: function(s, e){
  var mainElement = s.GetMainElement();
  if(!s.gvClickArgs)
   s.gvClickArgs = eval(ASPx.Attr.GetAttribute(mainElement, "data-args"));
  this.EnsureCommandButtonClickArgs(s);
  if(s.gvClickArgs && s.gvClickArgs.length > 1)
   this.ScheduleUserCommand(s.gvClickArgs[0], s.gvClickArgs[1], mainElement);
 },
 GetCommandButtonsInContainer: function(container) {
  var buttons = [];   
  ASPx.GetControlCollection().ProcessControlsInContainer(container, function(control){
   var isCommandButton = control.cpGVName === this.name && control.name.indexOf("DXCBtn") > -1;
   if(isCommandButton)
    buttons.push(control);
  }.bind(this));
  return buttons;
 },
 IsRecoverButton: function(button) {
  this.EnsureCommandButtonClickArgs(button);
  return button.gvClickArgs[0] && button.gvClickArgs[0][0] === "Recover" ;
 },
 IsCancelButton: function(button) {
  this.EnsureCommandButtonClickArgs(button);
  return button.gvClickArgs[0] && button.gvClickArgs[0][0] === "CancelEdit" ;
 },
 CheckEndlessPagingLoadNextPage: function() {
  window.setTimeout(function() {
   var scrollHelper = this.GetScrollHelper();
   if(this.useEndlessPaging && scrollHelper)
    scrollHelper.CheckEndlessPagingLoadNextPage();
  }.aspxBind(this), 0);
 },
 EnsureRowKeys: function() {
  if(ASPx.IsExists(this.stateObject.keys))
   this.keys = this.stateObject.keys;
  if(!this.keys)
   this.keys = [ ];
 }, 
 CheckPendingEvents: function() {
  if(this.pendingEvents.length < 1)
   return;
  for(var i = 0; i < this.pendingEvents.length; i++)
   this.ScheduleRaisingEvent(this.pendingEvents[i]);
  this.pendingEvents.length = 0;
 },
 ScheduleRaisingEvent: function(eventName) {
  window.setTimeout(function() { this[eventName](); }.aspxBind(this), 0);
 },
 CreateInternalCheckBoxCollection: function() {
  if(!this.internalCheckBoxCollection)
   this.internalCheckBoxCollection = new ASPx.CheckBoxInternalCollection(this.checkBoxImageProperties, true, undefined, undefined, undefined, this.accessibilityCompliant);
  else
   this.internalCheckBoxCollection.SetImageProperties(this.checkBoxImageProperties);
  this.CompleteInternalCheckBoxCollection();
 },
 CompleteInternalCheckBoxCollection: function() {
  if(!this.IsLastCallbackProcessedAsEndless()){
   this.internalCheckBoxCollection.Clear();
   for(var i = 0; i < this.selectAllSettings.length; i++){
    var selectAllSettings = this.selectAllSettings[i];
    if(selectAllSettings === null)
     continue;
    var icbSelectAllElement = this.GetSelectAllBtn(selectAllSettings.index);
    if(ASPx.IsExistsElement(icbSelectAllElement))
     this.AddInternalCheckBoxToCollection(icbSelectAllElement, -(selectAllSettings.index + 1), !this.IsCheckBoxDisabled(icbSelectAllElement));
   }
  }
  for(var i = 0; i < this.pageRowCount; i ++) {
   var index = i + this.visibleStartIndex;
   var icbInputElement = this.GetDataRowSelBtn(index);
   if(icbInputElement) {
    var enabled = !this.IsCheckBoxDisabled(icbInputElement);
    this.AddInternalCheckBoxToCollection(icbInputElement, index, enabled);
   }
  }
 },
 IsCheckBoxDisabled: function(icbInputElement) {
  var icbMainElement = ASPx.CheckableElementHelper.Instance.GetICBMainElementByInput(icbInputElement);
  return icbMainElement.className.indexOf(this.GetDisabledCheckboxClassName()) != -1;
 },
 GetCssClassNamePrefix: function() { return ""; },
 GetDisabledCheckboxClassName: function() { return this.GetCssClassNamePrefix() + "_cd"; },
 AddInternalCheckBoxToCollection: function (icbInputElement, visibleIndex, enabled) {
  var internalCheckBox = null;
  if(this.IsLastCallbackProcessedAsEndless())
   internalCheckBox = this.internalCheckBoxCollection.Get(icbInputElement.id);
  if(internalCheckBox && internalCheckBox.inputElement != icbInputElement){
   this.internalCheckBoxCollection.Remove(icbInputElement.id);
   internalCheckBox = null;
  }
  if(!internalCheckBox)
   internalCheckBox = this.internalCheckBoxCollection.Add(icbInputElement.id, icbInputElement);
  internalCheckBox.CreateFocusDecoration(this.icbFocusedStyle);
  internalCheckBox.SetEnabled(enabled && this.GetEnabled());
  internalCheckBox.readOnly = this.readOnly;
  internalCheckBox.autoSwitchEnabled = !this.allowSelectSingleRowOnly;
  var grid = this;
  function OnCheckedChanged(s, e){
   if(!s.autoSwitchEnabled && s.GetValue() == ASPx.CheckBoxInputKey.Unchecked){
    var value = s.stateController.GetNextCheckBoxValue(s.GetValue(), s.allowGrayedByClick && s.allowGrayed);
    s.SetValue(value);
   }
   var rowCheckBox = grid.GetDataRowSelBtn(visibleIndex);
   if(grid.allowSelectSingleRowOnly)
    grid._selectAllSelBtn(false, rowCheckBox.id);
   if(!grid.RaiseInternalCheckBoxClick(visibleIndex)){
    grid.ScheduleCommand(function() { grid.SelectItem(visibleIndex, s.GetChecked()); }, true);
    grid.mainTableClickCore(e, true);
   }
  }
  function OnSelectAllCheckedChanged(s, e) {
   grid.ScheduleCommand(function() { this.ProcessSelectAllCheckBoxCheckedChanged(s); }.bind(grid), true);
   grid.mainTableClickCore(e, true);
  }
  var checkedChangedHandler = visibleIndex < 0 ? OnSelectAllCheckedChanged : OnCheckedChanged;
  internalCheckBox.CheckedChanged.AddHandler(checkedChangedHandler);
 },
 ProcessSelectAllCheckBoxCheckedChanged: function(checkBox, e) {
  var index = this.tryGetNumberFromEndOfString(checkBox.inputElement.id).value;
  var columnSelectAllSettings = this.GetColumnSelectAllSettings(index);
  if(!columnSelectAllSettings)
   return;
  switch(columnSelectAllSettings.mode){
   case 1:
    if(checkBox.GetChecked())
     this.SelectAllItemsOnPage();
    else 
     this.UnselectAllItemsOnPage();
    break;
   case 2:
    if(checkBox.GetChecked())
     this.SelectItemsCore(null, true, true);
    else 
     this.UnselectFilteredItemsCore(true);
    break;
  }
  this.UpdateSelectAllCheckboxesState();
 },
 GetColumnSelectAllSettings: function(index){
  for(var i = 0; i < this.selectAllSettings.length; i++){
   if(this.selectAllSettings[i].index == index)
    return this.selectAllSettings[i];
  }
 },
 SelectItemsCore: function(visibleIndices, selected, changedBySelectAll){
  if(!ASPx.IsExists(selected)) selected = true;
  if(!ASPx.IsExists(visibleIndices)) {
   selected = selected ? "all" : "unall";
   changedBySelectAll = ASPx.IsExists(changedBySelectAll) ? changedBySelectAll : false;
   visibleIndices = [ ];
  } else {
   changedBySelectAll = false;
   if(visibleIndices.constructor != Array)
    visibleIndices = [visibleIndices];
  }
  this.gridCallBack([ASPxClientGridViewCallbackCommand.SelectRows, selected, changedBySelectAll].concat(visibleIndices));
 },
 UnselectFilteredItemsCore: function(changedBySelectAll){
  if(!ASPx.IsExists(changedBySelectAll))
   changedBySelectAll = false;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.SelectRows, "unallf", changedBySelectAll]);
 },
 AdjustControlCore: function() {
  ASPxClientControl.prototype.AdjustControlCore.call(this);
  this.UpdateScrollableControls();
  this.ApplyPostBackSyncData();
  this.AdjustPagerControls();
  this.UpdateBatchEditActiveElements();
  this.InvalidateLayout();
 },
 UpdateBatchEditActiveElements: function () {
  var cellFocusHelper = this.GetCellFocusHelper();
  if(cellFocusHelper)
   cellFocusHelper.LoadUnfocusableAreaElements();
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   batchEditHelper.UpdateAllRecordActiveElements();
 },
 NeedCollapseControlCore: function() {
  return this.HasScrolling();
 },
 CollapseControl: function () {
  ASPx.GridCommonUtils.SaveActiveElement(this);
  ASPxClientControl.prototype.CollapseControl.call(this);
 },
 ExpandControl: function () {
  ASPxClientControl.prototype.ExpandControl.call(this);
  ASPx.GridCommonUtils.RestoreActiveElement(this);
 },
 InRegularCallback: function() {
  return this.InCallback() && !this.GetCallbackHelper().HasWaitedFuncCallbacks();
 },
 gridCallBack: function (args, callbackHandler) {
  this.GetCallbackHelper().SendRequest(args, callbackHandler);
 },
 gridPostBack: function(args) { 
  this.GetCallbackHelper().SendPostback(args); 
 },
 gridFuncCallBack: function(args, onCallBack) {
  this.GetCallbackHelper().SendFuncCallback(args, onCallBack);
 },
 OnCallback: function (result) {
  var html = result.html;
  this.HideFilterControlPopup();
  var isFuncCallback = html.indexOf("FB|") == 0;
  this.afterCallbackRequired = !isFuncCallback; 
  if(isFuncCallback)
   this.OnFunctionalCallback(html);
  else
   this.OnGeneralCallback(result);
 },
 OnGeneralCallback: function(result) {
  var html = result.html;
  this.UpdateStateObjectWithObject(result.stateObject);
  this.GetFilterHelper().LoadSearchEditorValueOnCallback();
  if(this.RequirePartialUpdate(html))
   this.ProcessPartialCallbackResult(html);
  else
   this.ProcessFullCallbackResult(html);
 },
 RequirePartialUpdate: function(html) {
  var helper = this.GetEndlessPagingHelper();
  return html.indexOf("EP|") == 0 && helper;
 },
 ProcessPartialCallbackResult: function(result) {
  var helper = this.GetEndlessPagingHelper();
  helper.OnCallback(result);
 },
 ProcessFullCallbackResult: function(result) {
  var rootTD = this.GetGridTD();
  if(rootTD)
   ASPx.SetInnerHtml(rootTD, result);
 },
 OnFunctionalCallback: function(result){
  this.PreventCallbackAnimation();
  var result = this.ParseFuncCallbackResult(result.substr(3));
  if(!result) return;
  if(this.IsHeaderFilterFuncCallback(result.callback))
   this.OnFuncCallback(result);
  else 
   window.setTimeout(function() { this.OnFuncCallback(result); }.aspxBind(this), 0);
 },
 OnCallbackFinalized: function() {
  if(this.afterCallbackRequired)
   this.OnAfterCallback();
 },
 IsHeaderFilterFuncCallback: function(callback) {
  return callback === this.GetFilterHelper().OnHeaderFilterCallback;
 },
 ParseFuncCallbackResult: function(result) {
  var pos = result.indexOf("|");
  if(pos < 0) return;
  var index = parseInt(result.substr(0, pos), 10);
  var info = this.GetCallbackHelper().GetFuncCallBackInfo(index);
  if(info && info.callback)
   return { callback: info.callback, params: result.substr(pos + 1) };
 },
 OnFuncCallback: function(result) {
  if(result && result.callback)
   result.callback(eval(result.params));
 },
 OnCallbackErrorAfterUserHandle: function(errorMessage, data) {
  this.SetCallbackErrorData(errorMessage, data, true);
 },
 OnCallbackError: function(result, data){
  this.SetCallbackErrorData(result, data, false);
  this.SetAfterCallbackRequired();
 },
 SetAfterCallbackRequired: function() {
  if(this.GetGridTD())
   this.afterCallbackRequired = true;
 },
 SetCallbackErrorData: function(errorMessage, data, userHandled) {
  this.showingError = errorMessage;
  this.errorData = data;
  this.userHandledCallbackError = userHandled;
 },
 ShowCallbackError: function(errorText, errorData) {
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper && batchEditHelper.ShowCallbackError(errorText, errorData))
   return;
  var displayIn = this;
  var popupForm = this.GetPopupEditForm();
  if(popupForm) {
   displayIn = popupForm;
   this.ShowPopupEditForm();
  }
  this.ShowCallbackErrorCore(displayIn, errorText);
 },
 ShowCallbackErrorCore: function(displayIn, errorText) {
  var errorTextContainer = this.GetErrorTextContainer(displayIn);
  if(errorTextContainer)
   errorTextContainer.innerHTML = errorText;
  else
   ASPx.ShowErrorAlert(errorText);
 },
 GetErrorTextContainer: function(displayIn) { },
 CreateEditingErrorItem: function(visibleIndex) { },
 CancelCallbackCore: function() {
  this.RestoreCallbackSettings();
  this.AddSelectStartHandler();
  if(this.isAccessibleFilterRowMenu)
   this.AddKeyDownFilterRowButtonHandler();
  this.ResetGestureElementPosition();
  this.GetFilterHelper().OnCancelCallbackCore();
  this.keyboardLock = false;
 },
 ResetGestureElementPosition: function() {  
  if(!ASPx.GesturesHelper) return;
  var handler = ASPx.GesturesHelper.handlers[this.name];
  if(handler)
   handler.ResetGestureElementPosition();
 },
 OnBeforeCallbackOrPostBack: function() {
  this.GetFilterHelper().LockFilter();
  this.HidePopupEditForm();
  ASPxClientGridBase.SaveActiveElementSettings(this);
 },
 OnBeforeCallback: function(command) {
  this.GetFilterHelper().OnBeforeCallback();
  this.keyboardLock = true;
  var endlessPagingHelper = this.GetEndlessPagingHelper();
  if(endlessPagingHelper)
   endlessPagingHelper.OnBeforeCallback(command);
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   scrollHelper.OnBeforeCallback(command);
  var cellFocusHelper = this.GetCellFocusHelper();
  if(cellFocusHelper)
   cellFocusHelper.OnBeforeCallback();
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   batchEditHelper.OnBeforeCallback();
  this.ShowLoadingElements();
  this.SaveCallbackSettings();
  this.RemoveSelectStartHandler();
  if(this.accessibilityCompliant)
   this.isAccessibleRowEditing = this.IsRowEditingCommand(command);
 },
 IsRowEditingCommand: function(command) {
  return command == ASPxClientGridViewCallbackCommand.AddNewRow || 
      command == ASPxClientGridViewCallbackCommand.StartEdit;
 },
 OnAfterCallback: function() {
  this.Invalidate();
  this.GetFilterHelper().OnAfterCallback();
  this.GetToolbarHelper().OnAfterCallback();
  var checkBoxCollectionReinitializeRequired = !this.HasCallbackError(); 
  this.ProcessGridCallbackError();
  this.pendingCommands = [ ];
  try {
   this._setFocusedItemInputValue();
   this.EnsureRowKeys();
   this.SetHeadersClientEvents();
   this.RestoreCallbackSettings();
   this.AddSelectStartHandler();
   if(this.isAccessibleFilterRowMenu)
    this.AddKeyDownFilterRowButtonHandler();
   this.EnsureRowHotTrackItems();
   if(this.kbdHelper && !this.useEndlessPaging)
    this.kbdHelper.EnsureFocusedRowVisible();
  }
  finally {
   this.keyboardLock = false;
  }
  this.CheckPendingEvents();
  this.PrepareCommandButtons();
  var endlessPagingHelper = this.GetEndlessPagingHelper();
  if(endlessPagingHelper)
   endlessPagingHelper.OnAfterCallback();
  if(this.checkBoxImageProperties && checkBoxCollectionReinitializeRequired){
   this.CreateInternalCheckBoxCollection();
   this.UpdateSelectAllCheckboxesState();
  }
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   batchEditHelper.OnAfterCallback();
  var cellFocusHelper = this.GetCellFocusHelper();
  if(cellFocusHelper)
   cellFocusHelper.OnAfterCallback();
  this.CheckEndlessPagingLoadNextPage();
  window.setTimeout(function() { this.EnsureVisibleRowFromServer(); }.aspxBind(this), 0);
  if(this.isAccessibleRowEditing)
   this.HandleAccessibleFocusForEditingRow();
 },
 HasCallbackError: function() { return !!this.showingError; },
 ProcessGridCallbackError: function() {
  if(!this.HasCallbackError()) return;
  if(this.userHandledCallbackError)
   this.ProcessCallbackErrorAfterUserHandle();
  else
   this.ShowCallbackError(this.showingError, this.errorData);
  this.SetCallbackErrorData(null, null, false);
 },
 ProcessCallbackErrorAfterUserHandle: function() {
  this.ShowPopupEditForm();
 },
 SaveCallbackSettings: function() {
  this.SaveCustWindowScroll();
 },
 RestoreCallbackSettings: function() {
  this.RestoreCustWindowScroll();
  this.ApplyPostBackSyncData();
  this.ResetControlAdjustment(); 
  ASPxClientGridBase.RestoreActiveElementSettings(this); 
 },
 SaveCustWindowScroll: function() {
  var custWindow = this.GetCustomizationWindow();
  var contentContainer = custWindow && custWindow.IsVisible() && custWindow.GetContentContainer(-1);
  if(contentContainer)
   this.savedCustWindowScroll = { left: contentContainer.scrollLeft, top: contentContainer.scrollTop };
 },
 RestoreCustWindowScroll: function() {   
  var custWindow = this.GetCustomizationWindow();
  var contentContainer = custWindow && custWindow.IsVisible() && custWindow.GetContentContainer(-1);
  if(contentContainer && ASPx.IsExists(this.savedCustWindowScroll)) {
   contentContainer.scrollLeft = this.savedCustWindowScroll.left;
   contentContainer.scrollTop = this.savedCustWindowScroll.top;
  }
 },
 ShowPopupEditForm: function() {
  var popupForm = this.GetPopupEditForm();
  if(popupForm && !popupForm.IsVisible())
   popupForm.Show();
 },
 HidePopupEditForm: function() {
  var popup = this.GetPopupEditForm();
  if(popup)
   popup.Hide();
 },
 OnPopupEditFormInit: function(popup) {
  if(this.HasHorzScroll() && this.GetVisibleItemsOnPage() > 0) {
   var popupHorzOffset = popup.GetPopupHorizontalOffset();
   popup.SetPopupHorizontalOffset(popupHorzOffset - this.GetPopupEditFormHorzOffsetCorrection(popup));
  }
  popup.Show();
 },
 GetPopupEditFormHorzOffsetCorrection: function(popup) {
  return 0;
 },
 HandleAccessibleFocusForEditingRow: function() {
  var editingRow = this.GetEditingRow();
  if(!editingRow || !this.accessibilityFocusTreeLine)
   return;
  var focusElement = ASPx.FindFirstChildActionElement(editingRow, function(element) {
   return !this.IsCommandColumnItem(element);
  }.aspxBind(this));
  this.accessibilityFocusTreeLine = ASPx.RestoreFocusHelper.getTreeLineCore(this.GetMainElement(), focusElement);
  this.isAccessibleRowEditing = false;
 },
 _isRowSelected: function(visibleIndex) {
  if(!ASPx.IsExists(this.stateObject.selection)) return false;
  var index = this._getItemIndexOnPage(visibleIndex);
  return this._isTrueInCheckList(this.stateObject.selection, index);
 },
 _isTrueInCheckList: function(checkList, index) {
  if(index < 0 ||  index >= checkList.length) return false;
  return checkList.charAt(index) == "T";
 },
 _getSelectedRowCount: function() {
  return this.selectedWithoutPageRowCount + this._getSelectedRowCountOnPage();
 },
 _getSelectedRowCountOnPage: function(){
  if(!ASPx.IsExists(this.stateObject.selection))
   return 0;
  var checkList = this.stateObject.selection;
  var selCount = 0;
  for(var i = 0; i < checkList.length; i++) {
   if(checkList.charAt(i) == "T") selCount ++;
  }
  return selCount;
 },
 _selectAllRowsOnPage: function(checked) {
  if(checked && this.allowSelectSingleRowOnly) {
   this.SelectItem(0, true);
   return;
  }
  if(!ASPx.IsExists(this.stateObject.selection)) return;
  this._selectAllSelBtn(checked);
  var prevSelectedRowCount = 0;
  var isTrueInCheckList = false;
  for(var i = 0; i < this.pageRowCount; i ++) {
   isTrueInCheckList = this._isTrueInCheckList(this.stateObject.selection, i);
   if(isTrueInCheckList) prevSelectedRowCount++; 
   if(isTrueInCheckList != checked)
    this.ChangeItemStyle(i + this.visibleStartIndex, this.GetSelectedItemStyle(checked));
  }
  if (prevSelectedRowCount == 0 && !checked) return;
  var selValue = "";
  if(checked) {
   for(var i = 0; i < this.pageRowCount; i ++)
    selValue += this.IsDataItem(this.visibleStartIndex + i ) ? "T" : "F";
  }
  if(selValue != this.stateObject.selection) {
   this.userChangedSelection = true;
   if(selValue == "") selValue = "U";
   this.stateObject.selection = selValue;
  }
  this.DoSelectionChanged(-1, checked, true);
  this.UpdateSelectAllCheckboxesState();
 },
 SelectAllItemsOnPage: function(selected) {
  if(!ASPx.IsExists(selected)) selected = true;
  this._selectAllRowsOnPage(selected);
 },
 UnselectAllItemsOnPage: function() {
  this.SelectAllItemsOnPage(false);
 },
 DeleteGridItem: function(visibleIndex) {
  if(!this.allowDelete || (this.confirmDelete != "" && !confirm(this.confirmDelete))) 
   return;
  this.DeleteItem(visibleIndex);
 },
 _selectAllSelBtn: function(checked, exceptName) {
  if(!this.checkBoxImageProperties) return;
  this.internalCheckBoxCollection.elementsMap.forEachEntry(function(key, checkBox) {
   if(key !== exceptName && checkBox.SetValue)
    checkBox.SetValue(checked ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
  });
 },
 doRowMultiSelect: function(row, rowIndex, evt) {
  var ctrlKey = evt.ctrlKey || evt.metaKey,
   shiftKey = evt.shiftKey;
  if((ctrlKey || shiftKey) && (!ASPx.Browser.IE || ASPx.Browser.Version > 8))
   ASPx.Selection.Clear();
  if(this.allowSelectSingleRowOnly)
   shiftKey = false;
  if(!ctrlKey && !shiftKey) {
   if(this._getSelectedRowCountOnPage() === 1 && this._isRowSelected(rowIndex))
    return;
   this._selectAllRowsOnPage(false);
   this.SelectItem(rowIndex, true);
   this.lastMultiSelectIndex = rowIndex;
  } else {
   if(ctrlKey) {
    this.SelectItem(rowIndex, !this._isRowSelected(rowIndex));
    this.lastMultiSelectIndex = rowIndex;
   } else {
    var startIndex = rowIndex > this.lastMultiSelectIndex ? this.lastMultiSelectIndex + 1 : rowIndex;
    var endIndex = rowIndex > this.lastMultiSelectIndex ? rowIndex : this.lastMultiSelectIndex - 1;
    for(var i = this.visibleStartIndex; i < this.pageRowCount + this.visibleStartIndex; i ++) {
     if(i == this.lastMultiSelectIndex) 
      continue;
     this.SelectItem(i, i >= startIndex && i <= endIndex);
    }
   }
  }
  this.UpdatePostBackSyncInput();
 },
 AddSelectStartHandler: function() {   
  if(!this.allowSelectByItemClick || !ASPx.Browser.IE || ASPx.Browser.Version > 8 )
   return;
  ASPx.Evt.AttachEventToElement(this.GetMainTable(), "selectstart", ASPxClientGridBase.SelectStartHandler);
 },
 AddKeyDownFilterRowButtonHandler: function() {
  var filterRow = this.GetFilterRow();
  if(!filterRow)
   return;
  var buttons = [];
  ASPx.GetNodesByPartialId(filterRow, this.AccessibleFilterRowButtonID, buttons);
  for(var i = 0; i < buttons.length; i++)
   ASPx.Evt.AttachEventToElement(buttons[i], "keydown", ASPx.Evt.InvokeMouseClickByKeyDown);
 },
 RemoveSelectStartHandler: function() {
  if(!this.allowSelectByItemClick || !ASPx.Browser.IE)
   return; 
  ASPx.Evt.DetachEventFromElement(this.GetMainTable(), "selectstart", ASPxClientGridBase.SelectStartHandler);
 },
 SelectItemsByKey: function(keys, selected){
  if(!ASPx.IsExists(selected)) selected = true;
  if(!ASPx.IsExists(keys)) return;
  if(keys.constructor != Array)
   keys = [keys];
  this.gridCallBack([ASPxClientGridViewCallbackCommand.SelectRowsKey, selected].concat(keys));
 },
 SelectItem: function(visibleIndex, checked, fromCheckBox) {
  if(!this.IsPossibleSelectItem(visibleIndex, checked)) return;
  if(ASPx.IsExists(fromCheckBox)) fromCheckBox = false;
  var index = this._getItemIndexOnPage(visibleIndex);
  if(index < 0) return;
  if(checked && this.allowSelectSingleRowOnly)
   this._selectAllRowsOnPage(false);
  if(ASPx.IsExists(this.stateObject.selection)) {
   this.userChangedSelection = true;
   var checkList = this.stateObject.selection;
   if(index >= checkList.length) {
    if(!checked) return;
    for(var i = checkList.length; i <= index; i ++)
     checkList += "F";
   }
   checkList = checkList.substr(0, index) + (checked ? "T" : "F") + checkList.substr(index + 1, checkList.length - index - 1);
   if(checkList.indexOf("T") < 0) checkList = "U";
   this.stateObject.selection = checkList;
  }
  this.selectItemCheckbox(visibleIndex, checked);
  this.UpdateSelectAllCheckboxesState();
  this.ChangeItemStyle(visibleIndex, this.GetSelectedItemStyle(checked));
  this.DoSelectionChanged(visibleIndex, checked, false);
 },
 selectItemCheckbox: function(visibleIndex, checked) {
  var checkBox = this.GetDataRowSelBtn(visibleIndex);
  if(checkBox) {
   var internalCheckBox = this.internalCheckBoxCollection.Get(checkBox.id);
   if(internalCheckBox)
    internalCheckBox.SetValue(checked ? ASPx.CheckBoxInputKey.Checked : ASPx.CheckBoxInputKey.Unchecked);
  }
 },
 IsPossibleSelectItem: function(visibleIndex, newSelectedValue){
  if(this.IsBatchEditDeletedItem(visibleIndex))
   return false;
  return visibleIndex > -1 && this._isRowSelected(visibleIndex) != newSelectedValue;
 },
 UpdateSelectAllCheckboxesState: function(){
  if(!this.selectAllSettings)
   return;
  for(var i = 0; i < this.selectAllSettings.length; i++){
   var columnSelectAllSettings = this.selectAllSettings[i];
   if(columnSelectAllSettings === null)
    continue;
   var selectAllButtonInput = this.GetSelectAllBtn(columnSelectAllSettings.index);
   if(selectAllButtonInput && !this.IsCheckBoxDisabled(selectAllButtonInput))
    this.UpdateSelectAllCheckboxStateCore(selectAllButtonInput, columnSelectAllSettings.mode);
  }
 },
 UpdateSelectAllCheckboxStateCore: function(selectAllButtonInput, selectMode){
  var value = ASPx.CheckBoxInputKey.Indeterminate;
  var selectedRowCountOnPage = this.GetSelectedKeysOnPage().length;
  var considerSelectionOnPages = selectMode == 2 && this.selectAllBtnStateWithoutPage !== null;
  if(this.GetDataItemCountOnPage() == selectedRowCountOnPage && (!considerSelectionOnPages || this.selectAllBtnStateWithoutPage == ASPx.CheckBoxInputKey.Checked))
   value = ASPx.CheckBoxInputKey.Checked;
  else if(selectedRowCountOnPage == 0 && (!considerSelectionOnPages || this.selectAllBtnStateWithoutPage == ASPx.CheckBoxInputKey.Unchecked))
   value = ASPx.CheckBoxInputKey.Unchecked;
  var selectAllCheckBoxInst = this.internalCheckBoxCollection.Get(selectAllButtonInput.id);
  selectAllCheckBoxInst.SetValue(value);
 },
 GetDataItemCountOnPage: function(){
  return this.pageRowCount;
 },
 ScheduleUserCommand: function(args, postponed, eventSource) {
  if(!args || args.length == 0) 
   return;
  var commandName = args[0];
  var rowCommands = this.GetUserCommandNamesForRow();
  if((this.useEndlessPaging || this.allowBatchEditing) && ASPx.Data.ArrayIndexOf(rowCommands, commandName) > -1)
   args[args.length - 1] = this.FindParentRowVisibleIndex(eventSource, true);
  postponed &= this.IsMainTableChildElement(eventSource);
  this.ScheduleCommand(args, postponed);
 },
 GetUserCommandNamesForRow: function() { return [ "CustomButton", "Select", "StartEdit", "Delete", "Recover", "CancelEdit" ]; },
 IsMainTableChildElement: function(src) { return true; },
 FindParentRowVisibleIndex: function(element, dataAndGroupOnly) {
  var regEx = this.GetItemVisibleIndexRegExp(dataAndGroupOnly);
  var editingRow = this.GetEditingRow();
  while(element) {
   if(element.tagName === "BODY" || element.id == this.name)
    return this.InvalidItemIndex;
   var matches = regEx.exec(element.id);
   if(matches && matches.length == 3)
    return parseInt(matches[2]);
   if(element === editingRow)
    return this.editItemVisibleIndex;
   element = element.parentNode;
  }
  return this.InvalidItemIndex;
 },
 GetItemVisibleIndexRegExp: function(dataAndGroupOnly) {
  return this.GetItemVisibleIndexRegExpByIdParts();
 },
 GetItemVisibleIndexRegExpByIdParts: function(idParts){
  if(!idParts) idParts = [ ];
  return new RegExp("^(" + this.name + "_(?:" + idParts.join("|") + "))(-?\\d+)(?:_\\d+)?$");
 },
 ScheduleCommand: function(args, postponed) {
  if(postponed)
   this.pendingCommands.push(args);
  else 
   this.PerformScheduledCommand(args);
 },
 PerformScheduledCommand: function(args) {
  if(ASPx.IsFunction(args)) {
   args(); 
   return;
  }
  if(args && args.length > 0) {
   var commandName = "UA_" + args[0];
   if(this[commandName])
    this[commandName].apply(this, args.slice(1));
  }
 },
 PerformPendingCommands: function() {
  var commandCount = this.pendingCommands.length;
  for(var i = 0; i < commandCount; i++)
   this.PerformScheduledCommand(this.pendingCommands.pop());
 },
 getItemByHtmlEvent: function(evt) { return null; },
 getItemByHtmlEventCore: function(evt, partialID) {
  var item = ASPx.GetParentByPartialId(ASPx.Evt.GetEventSource(evt), partialID);
  if(item && item.id.indexOf(this.name) > -1)
   return item;
  return null;
 },
 NeedProcessTableClick: function(evt) {
  var source = ASPx.Evt.GetEventSource(evt);
  var handlingControl = this.GetTableClickHandlingControl(source);
  return handlingControl && this === handlingControl;
 },
 GetTableClickHandlingControl: function(source) {
  var treeLine = ASPx.GetElementTreeLine(source);
  for(var i = 0; i < treeLine.length; i++) {
   var control = ASPx.GetControlCollection().GetByName(treeLine[i].id);
   if(control && control instanceof ASPxClientGridBase)
    return control;
  }
  return null;
 },
 mainTableClick: function(evt) { this.mainTableClickCore(evt); },
 mainTableDblClick: function(evt) { 
  var item = this.getItemByHtmlEvent(evt);
  if(!item) return;
  var forceItemDblClickEvent = true;
  var itemIndex = this.getItemIndex(item.id);
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper){
   batchEditHelper.ProcessTableClick(item, ASPx.Evt.GetEventSource(evt), true);
   forceItemDblClickEvent = batchEditHelper.GetEditingRecordKey() !== this.ConvertVisibleIndexToKey(itemIndex);
  }
  if(forceItemDblClickEvent)
   this.RaiseItemDblClick(itemIndex, evt);
 },
 mainTableClickCore: function(evt, fromCheckBox) {
  if(this.kbdHelper)
   this.kbdHelper.HandleClick(evt);
  var sendNotificationCallback = true;
  this.mainTableClickData.processing = true;
  try {
   this.ProcessTableClick(evt, fromCheckBox);
   var callbackHelper = this.GetCallbackHelper();
   var savedRequestCount = callbackHelper.GetTotalRequestCount();
   this.PerformPendingCommands();
   var currentRequestCount = callbackHelper.GetTotalRequestCount();
   sendNotificationCallback = currentRequestCount === savedRequestCount;
  } finally {
   if(sendNotificationCallback)
    if(this.mainTableClickData.focusChanged && !this.mainTableClickData.selectionChanged) {
     this.gridCallBack([ASPxClientGridViewCallbackCommand.FocusedRow]);
    } else if(this.mainTableClickData.selectionChanged) {
     this.gridCallBack([ASPxClientGridViewCallbackCommand.Selection]);
    }
   this.mainTableClickData.processing = false;
   this.mainTableClickData.focusChanged = false;
   this.mainTableClickData.selectionChanged = false;
  }
 },
 ProcessTableClick: function(evt, fromCheckBox) {
  var source = ASPx.Evt.GetEventSource(evt);
  var item = this.getItemByHtmlEvent(evt);
  if(item) {
   var itemIndex = this.getItemIndex(item.id);
   var isCommandColumnItem = this.IsCommandColumnItem(source);
   if(!isCommandColumnItem && !fromCheckBox) {
    var batchEditHelper = this.GetBatchEditHelper();
    if(batchEditHelper && batchEditHelper.ProcessTableClick(item, source))
     return;
    if(this.RaiseItemClick(itemIndex, evt)) 
     return;
   }
   var prevFocusedItemIndex = this._getFocusedItemIndex();
   if(this.CanTryFocusItemOnTableClick())
    this.TryFocusItem(itemIndex, evt);
   if(this.allowSelectByItemClick) {
    if(!this.testActionElement(source) && !isCommandColumnItem && !fromCheckBox) {
     if(this.lookupBehavior) {
      var checked = this.allowSelectSingleRowOnly || !this._isRowSelected(itemIndex);
      this.SelectItem(itemIndex, checked);
     } else {
      if(!fromCheckBox && !evt.shiftKey && this.RequireProcessTableClickLikeCheckBoxClick(source, itemIndex)) { 
       var newSelected = this.allowSelectSingleRowOnly || !this._isRowSelected(itemIndex);
       this.SelectItem(itemIndex, newSelected);
       return;
      }
      var indexCorrection = 0;
      if(this.lastMultiSelectIndex < 0 && prevFocusedItemIndex > -1) {
       if(evt.shiftKey && itemIndex != prevFocusedItemIndex && !this._isRowSelected(prevFocusedItemIndex))
        indexCorrection = itemIndex > prevFocusedItemIndex ? -1 : 1;
       this.lastMultiSelectIndex = prevFocusedItemIndex + indexCorrection;
      }
      this.doRowMultiSelect(item, itemIndex, evt);
      this.lastMultiSelectIndex -= indexCorrection;
     }
    }
   } else {
    this.lastMultiSelectIndex = itemIndex;
   }
  }
 },
 testActionElement: function(element) {
  return element && element.tagName.match(/input|select|textarea|^a$/i);
 },
 IsCommandColumnItem: function(element) {
  if(!element) return false;
  if(ASPx.ElementHasCssClass(element, this.CommandColumnItemClassName))
   return true;
  return ASPx.GetIsParent(this.GetMainElement(), ASPx.GetParentByPartialId(element, "DXCBtn"));
 },
 RequireProcessTableClickLikeCheckBoxClick: function(tableClickSource, visibleIndex) { return false; },
 OnBeforeFocusedCellChanging: function(cellInfo, htmlEvent) {
  var visibleIndex = this.ConvertKeyToVisibleIndex(cellInfo.recordKey);
  if(this.allowFocusedRow && visibleIndex >= 0 && visibleIndex !== this.focusedRowIndex && !this.IsBatchEditDeletedItem(visibleIndex)) 
   return this.RaiseItemFocusing(visibleIndex, htmlEvent);
  return false;
 },
 OnFocusedCellChanged: function(cellInfo) {
  this._setFocusedItemIndex(this.ConvertKeyToVisibleIndex(cellInfo.recordKey));
  if(!this.allowFocusedRow)
   this.ChangeToolbarItemsEnabling();
 },
 CanTryFocusItemOnTableClick: function() { return !this.GetCellFocusHelper(); },
 TryFocusItem: function(visibleIndex, htmlEvent) {
  if(this.allowFocusedRow && visibleIndex >= 0 && visibleIndex !== this.focusedRowIndex && !this.IsBatchEditDeletedItem(visibleIndex)) {
   var isCanceledByUser = this.RaiseItemFocusing(visibleIndex, htmlEvent);
   if(!isCanceledByUser) {
    this._setFocusedItemIndex(visibleIndex);
    return true;
   }
  }
  return false;
 },
 _setFocusedItemIndex: function(visibleIndex) {
  if(visibleIndex < 0) 
   visibleIndex = -1;
  if(!this.allowFocusedRow || visibleIndex == this.focusedRowIndex || this.IsBatchEditDeletedItem(visibleIndex)) 
   return;
  var oldIndex = this.focusedRowIndex;
  this.focusedRowIndex = visibleIndex;
  this.ChangeFocusedItemStyle(oldIndex, false);
  this.ChangeFocusedItemStyle(this.focusedRowIndex, true);
  this._setFocusedItemInputValue();
  if(this.callbackOnFocusedRowChanged) {
   this.UpdatePostBackSyncInput(true);
   if(!this.mainTableClickData.processing) {
    this.gridCallBack([ASPxClientGridViewCallbackCommand.FocusedRow]);
   } else {
    this.mainTableClickData.focusChanged = true;
   }
   return;
  }
  this.ChangeToolbarItemsEnabling();
  this.RaiseFocusedItemChanged();
 },
 ChangeToolbarItemsEnabling: function(){
  var helper = this.GetToolbarHelper();
  helper.RefreshItemsState();
 },
 ChangeToolbarUpdateEditItemsEnabling: function(enabled) {
  var helper = this.GetToolbarHelper();
  if(helper)
   helper.OnUpdateEditEnabledChanged(enabled);
 },
 ChangeFocusedItemStyle: function(visibleIndex, focused) {
  if(visibleIndex < 0) return;
  var itemStyle = this.GetFocusedItemStyle(visibleIndex, focused);
  this.ChangeItemStyle(visibleIndex, itemStyle);
 },
 GetFocusedItemStyle: function(visibleIndex, focused){
  if(focused)
   return this.GetStyleHelper().GetFocusedItemStyle();
  return this.GetSelectedItemStyle(this._isRowSelected(visibleIndex));
 },
 GetFocusedCell: function() {
  var cellFocusHelper = this.GetCellFocusHelper();
  if(cellFocusHelper && cellFocusHelper.IsCellFocused()) {
   var info = cellFocusHelper.GetFocusedCellInfo();
   if(info)
    return this.CreateCellInfo(this.ConvertKeyToVisibleIndex(info.recordKey), this.GetColumn(info.columnIndex), info.recordKey);
  }
  return null;
 },
 SetFocusedCell: function(itemIndex, columnIndex) { this.SetFocusedCellByKey(this.ConvertVisibleIndexToKey(itemIndex), columnIndex); },
 SetFocusedCellByKey: function(key, columnIndex) {
  var cellFocusHelper = this.GetCellFocusHelper();
  if(cellFocusHelper)
   cellFocusHelper.SetFocusedCell(key, columnIndex);
 },
 _setFocusedItemInputValue: function() {
  if(ASPx.IsExists(this.stateObject.focusedRow)) 
   this.stateObject.focusedRow = this.focusedRowIndex;
 },
 _getFocusedItemIndex: function() {
  if(!this.allowFocusedRow) return -1;
  return this.focusedRowIndex;
 },
 getItemIndex: function(rowId) {   
  return this.tryGetNumberFromEndOfString(rowId).value;
 },
 tryGetNumberFromEndOfString: function(str) {
  var value = -1;
  var success = false;
  var n = str.length - 1;
  while(n >= 0 && !isNaN(parseInt(str.substr(n), 10))) {
   value = parseInt(str.substr(n), 10);
   success = true;
   n--;
  }
  return { success: success, value: value };
 },
 GetSelectedState: function() {
  if(!this.userChangedSelection) return null;
  if(!ASPx.IsExists(this.stateObject.selection)) return null;
  return this.stateObject.selection;
 },
 GetKeyValues: function() {
  return ASPx.Json.ToJson(this.stateObject.keys);
 },
 UpdateItemsStyle: function() {
  var start = this.GetTopVisibleIndex();
  var end = start + this.GetVisibleItemsOnPage();
  for(var i = start; i < end; i++) 
   this.UpdateItemStyle(i, this.GetItemStyle(i));
 },
 UpdateItemStyle: function(visibleIndex) {
  this.ChangeItemStyle(visibleIndex, this.GetItemStyle(visibleIndex));
 },
 GetSelectedItemStyle: function(selected) {
  var helper = this.GetStyleHelper();
  return selected ? helper.GetSelectedItemStyle() : helper.GetClearItemStyle();
 },
 GetItemStyle: function(visibleIndex){
  var helper = this.GetStyleHelper();
  var style = helper.GetClearItemStyle();
  if(this.IsBatchEditDeletedItem(visibleIndex))
   style = helper.GetBatchEditDeletedItemStyle();
  else if(this.allowFocusedRow && this._getFocusedItemIndex() == visibleIndex)
   style = helper.GetFocusedItemStyle();
  else if(this._isRowSelected(visibleIndex))
   style = helper.GetSelectedItemStyle();
  return style;
 },
 ChangeItemStyle: function(visibleIndex, rowStyle) {
  if(!this.RequireChangeItemStyle(visibleIndex, rowStyle))
   return;
  this.ApplyItemStyle(visibleIndex, rowStyle);
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   batchEditHelper.OnItemStyleChanged(this.GetItemKey(visibleIndex), rowStyle);
 },
 ApplyItemStyle: function(visibleIndex, styleInfo) {
  var item = this.GetItem(visibleIndex);
  this.ApplyElementStyle(item, styleInfo);
 },
 ApplyElementStyle: function(element, styleInfo) {  
  this.GetStyleHelper().ApplyElementStyle(element, styleInfo);
 },
 RequireChangeItemStyle: function(visibleIndex, itemStyle){
  var focusedIndex = this._getFocusedItemIndex();
  var helper = this.GetStyleHelper();
  if(focusedIndex > -1 && focusedIndex == visibleIndex && !helper.IsFocusedItemStyle(itemStyle))
   return false;
  return !!this.GetItem(visibleIndex);
 },
 _getItemIndexOnPage: function(visibleIndex) { 
  return visibleIndex - this.visibleStartIndex; 
 },
 getColumnIndex: function(colId) {
  if(this.IsEmptyHeaderID(colId))
   return -1;
  var index = this.tryGetNumberFromEndOfString(colId).value;
  var postfix = "col" + index;
  if(colId.lastIndexOf(postfix) == colId.length - postfix.length)
   return index;
  return -1;
 },
 getColumnObject: function(colId) {
  var index = this.getColumnIndex(colId);
  return index > -1 ? this._getColumn(index) : null;
 },
 _getColumnIndexByColumnArgs: function(column) {
  column = this._getColumnObjectByArg(column);
  if(!column) return null;
  return column.index;
 },
 _getColumnObjectByArg: function(arg) {
  if(!ASPx.IsExists(arg)) return null;
  if(typeof(arg) == "number") return this._getColumn(arg);
  if(ASPx.IsExists(arg.index)) return arg;
  var column = this._getColumnById(arg);
  if(column) return column;
  return this._getColumnByField(arg);  
 },
 _getColumnCount: function() { return this.columns.length; },
 _getColumn: function(index) {
  for(var i = 0; i < this.columns.length; i++){
   if(this.columns[i].index == index) return this.columns[i];
  }
  return null;
 },
 _getColumnById: function(id) {
  if(!ASPx.IsExists(id)) return null;
  for(var i = 0; i < this.columns.length; i++) {
   if(this.columns[i].id == id) return this.columns[i];
  }
  return null;
 },
 _getColumnByField: function(fieldName) {
  if(!ASPx.IsExists(fieldName)) return null;
  for(var i = 0; i < this.columns.length; i++) {
   if(this.columns[i].fieldName == fieldName) return this.columns[i];
  }
  return null;
 },
 DoSelectionChanged: function(index, isSelected, isSelectAllOnPage){
  if(this.callbackOnSelectionChanged) {
   this.UpdatePostBackSyncInput(true);
   if(!this.mainTableClickData.processing) {
    this.gridCallBack([ASPxClientGridViewCallbackCommand.Selection]);
   } else {
    this.mainTableClickData.selectionChanged = true;
   }
   return;
  }
  this.ChangeToolbarItemsEnabling();
  this.RaiseSelectionChanged(index, isSelected, isSelectAllOnPage, false);
 },
 CommandCustomButton:function(id, index) {
  var processOnServer = true;
  if(!this.CustomButtonClick.IsEmpty()) {
   var e = this.CreateCommandCustomButtonEventArgs(index, id);
   this.CustomButtonClick.FireEvent(this, e);
   processOnServer = e.processOnServer;
  }
  if(processOnServer)
   this.gridCallBack([ASPxClientGridViewCallbackCommand.CustomButton, id, index]);
 },
 CreateCommandCustomButtonEventArgs: function(index, id){
  return null;
 },
 HeaderMouseDown: function(element, e){
  if(!ASPx.Evt.IsLeftButtonPressed(e)) 
   return;
  var source = ASPx.Evt.GetEventSource(e);
  if(this.isHeaderFilterButton(source))
   return;
  if(this.TryStartColumnResizing(e, element))
   return;
  var canDrag = this.canDragColumn(element) && source.tagName != "IMG";
  var dragHelper = this.GetDragHelper();
  var drag = dragHelper.CreateDrag(e, element, canDrag);
  if(!canDrag && (e.shiftKey || e.ctrlKey))
   drag.clearSelectionOnce = true;
  dragHelper.CreateTargets(drag, e);
 },
 isHeaderFilterButton: function(el) {
  return ASPx.ElementContainsCssClass(ASPx.getSpriteMainElement(el), this.HeaderFilterButtonClassName);
 },
 TryStartColumnResizing: function(e, headerCell) {
  return false;
 }, 
 OnParentRowMouseEnter: function(element) {
  if(this.GetParentRowsWindow() == null) return;
  if(this.GetParentRowsWindow().IsWindowVisible()) return;
  this.ParentRowsTimerId = window.setTimeout(function() {
   var gv = ASPx.GetControlCollection().Get(this.name);
   if(gv)
    gv.OnParentRowsTimer(element.id);
  }.aspxBind(this), 500);
 },
 OnParentRowsTimer: function(rowId) {
  var element = ASPx.GetElementById(rowId);
  if(element)
   this.ShowParentRows(element);
 },
 OnParentRowMouseLeave: function(evt) {
  ASPx.Timer.ClearTimer(this.ParentRowsTimerId);
  if(this.GetParentRowsWindow() == null) return;
  if(evt && evt.toElement) {
   if(ASPx.GetParentByPartialId(evt.toElement, this.GetParentRowsWindow().name) != null)
    return;
  }
  this.HideParentRows();
 },
 ShowParentRows: function(element) {
  this.ParentRowsTimerId = null;
  if(this.GetParentRowsWindow() != null) {
   this.GetParentRowsWindow().ShowAtElement(element);
  }
 },
 HideParentRows: function() {
  this.ParentRowsTimerId = null;
  if(this.GetParentRowsWindow() != null) {
   this.GetParentRowsWindow().Hide();
  }
 }, 
 canSortByColumn: function(headerElement) {
  return this.getColumnObject(headerElement.id).allowSort;
 },
 canGroupByColumn: function(headerElement) {
  return false;
 },
 canDragColumn: function(headerElement) {
  return false;
 },
 doPagerOnClick: function(id) {
  if(!ASPx.IsExists(id)) return;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.PagerOnClick, id]);
 },
 CanHandleGesture: function(evt) {
  var source = ASPx.Evt.GetEventSource(evt);
  var table = this.GetMainTable();
  if(!table) return false;
  if(ASPx.GetIsParent(table, source))
   return !this.NeedPreventGestures(source, table);
  if(table.parentNode.tagName == "DIV" && ASPx.GetIsParent(table.parentNode, source))
   return ASPx.Browser.TouchUI || evt.offsetX < table.parentNode.clientWidth;
  return false;
 },
 AllowStartGesture: function() {
  return ASPxClientControl.prototype.AllowStartGesture.call(this) && 
   (this.AllowExecutePagerGesture(this.pageIndex, this.pageCount, 1) || this.AllowExecutePagerGesture(this.pageIndex, this.pageCount, -1));
 },
 AllowExecuteGesture: function(value) {
  return this.AllowExecutePagerGesture(this.pageIndex, this.pageCount, value);
 },
 ExecuteGesture: function(value, count) {
  this.ExecutePagerGesture(this.pageIndex, this.pageCount, value, count, function(arg) { this.doPagerOnClick(arg); }.aspxBind(this));
 },
 ApplySearchPanelFilter: function(value, isInternalCall) {
  if(!ASPx.IsExists(value))
   value = "";
  var edit = this.GetSearchEditor();
  if(edit && !isInternalCall)
   edit.SetText(value);
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   scrollHelper.ResetScrollTop();
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ApplySearchPanelFilter, value]);
 },
 NeedShowLoadingPanelInsideEndlessPagingContainer: function() {
  var endlessPagingHelper = this.GetEndlessPagingHelper();
  return endlessPagingHelper && endlessPagingHelper.NeedShowLoadingPanelAtBottom();
 },
 ShowLoadingPanel: function() {
  var gridMainCell = this.GetGridTD();
  if(!gridMainCell)
   return;
  if(this.NeedShowLoadingPanelInsideEndlessPagingContainer()) {
   var container = this.GetEndlessPagingLPContainer();
   ASPx.SetElementDisplay(container, true);
   this.CreateLoadingPanelWithoutBordersInsideContainer(container);
   return;
  }
  var lpContainer = this.GetLoadingPanelContainer();
  if(lpContainer)
   this.CreateLoadingPanelInline(lpContainer);
  else
   this.CreateLoadingPanelWithAbsolutePosition(gridMainCell, this.GetLoadingPanelOffsetElement(gridMainCell));
 },
 ShowLoadingDiv: function () {
  if(!this.NeedShowLoadingPanelInsideEndlessPagingContainer())
   this.CreateLoadingDiv(this.GetGridTD());
 },
 ShowLoadingPanelInsideHeaderFilterPopup: function() {
  this.CreateLoadingPanelWithoutBordersInsideContainer(this.GetHeaderFilterPopup().GetContentContainer(-1));
 },
 GetCallbackAnimationElement: function() {
  var table = this.GetMainTable();
  if(table && table.parentNode && table.parentNode.tagName == "DIV")
   return table.parentNode;
  return table;
 },
 NeedPreventTouchUIMouseScrolling: function(element) {
  return this.NeedPreventGestures(element);
 },
 NeedPreventGestures: function(element, mainElement) {
  if(!ASPx.IsExists(mainElement)) {
   mainElement = this.GetMainElement();
   if(!ASPx.IsExists(mainElement) || !ASPx.GetIsParent(mainElement, element))
    return false;
  }
  var preventElement = this.IsHeaderChild(element) || this.IsActionElement(mainElement, element);
  if(preventElement)
   return true;
  return this.pageCount <= 1 ? !ASPx.Browser.MSTouchUI : false;
 },
 IsHeaderChild: function(source) {
  return false;
 },
 IsActionElement: function(mainElement, source) {
  return false;
 },
 _updateEdit: function() {
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper && !batchEditHelper.CanUpdate())
   return;
  if(!batchEditHelper && !this._validateEditors())
   return;
  if(batchEditHelper)
   batchEditHelper.OnUpdate();
  this.gridCallBack([ASPxClientGridViewCallbackCommand.UpdateEdit]);
 },
 _validateEditors: function() {
  var editors = this._getEditors();
  var isValid = true;
  if(editors.length > 0)
   isValid &= this._validate(editors);
  if(window.ASPxClientEdit)
   isValid &= ASPxClientEdit.ValidateEditorsInContainer(this.GetEditFormTable(), this.name);
  return isValid;
 },
 _validate: function(list) {
  var isValid = true;
  var firstInvalid = null;
  var edit;
  for(var i = 0; i < list.length; i ++) {
   edit = list[i];
   edit.Validate();
   isValid = edit.GetIsValid() && isValid;
   if(firstInvalid == null && edit.setFocusOnError && !edit.GetIsValid())
    firstInvalid = edit;
  }
  if (firstInvalid != null)
   firstInvalid.Focus();
  return isValid;
 },
 _getEditors: function() {
  var list = [ ];
  for(var i = 0; i < this.editorIDList.length; i++) {
   var editor = ASPx.GetControlCollection().Get(this.editorIDList[i]);
   if(editor && editor.enabled && editor.GetMainElement && ASPx.IsExistsElement(editor.GetMainElement())) {
    if(!editor.Validate || this.IsStaticBinaryImageEditor(editor)) 
     continue; 
    list.push(editor);
   }
  }
  return list;
 },
 GetEditorValues: function() {
  if(this.allowBatchEditing) return null;
  var list = this._getEditors();
  if(list.length == 0) return null;
  var res = list.length + ";";
  for(var i = 0; i < list.length; i ++) {
   res += this.GetEditorValue(list[i]);
  }
  return res;
 },
 GetEditorValue: function(editor) {
  var value = editor.GetValueString();
  var valueLength = -1;
  if(!ASPx.IsExists(value)) {
   value = "";
  } else {
   value = value.toString();
   valueLength = value.length;
  }
  return this.GetEditorIndex(editor.name) + "," + valueLength + "," + value + ";";
 },
 GetEditorIndex: function(editorId) {
  var i = editorId.lastIndexOf(this.GetEditorPrefix());
  if(i < 0) return -1;
  var result = editorId.substr(i + this.GetEditorPrefix().length);
  i = result.indexOf('_'); 
  return i > 0
   ? result.substr(0, i)
   : result;
 },
 GetBatchEditHelper: function() {
  if(!this.allowBatchEditing) return null;
  if(!this.batchEditHelper)
   this.batchEditHelper = this.CreateBatchEditHelper(this.GetBatchEditHelperOwner());
  return this.batchEditHelper;
 },
 GetBatchEditHelperOwner: function() {
  if(!this.allowBatchEditing) return null;
  if(!this.batchEditHelperOwner)
   this.batchEditHelperOwner = this.CreateBatchEditHelperOwner();
  return this.batchEditHelperOwner;
 },
 CreateBatchEditHelper: function(owner) { return new ASPx.GridBatchEditHelper(owner); },
 CreateBatchEditHelperOwner: function() { },
 GetScrollHelper: function() { return null; },
 GetDragHelper: function() {
  if(!this.dragHelper)
   this.dragHelper = new GridViewDragHelper(this);
  return this.dragHelper;
 },
 GetEndlessPagingHelper: function() {
  if(!this.useEndlessPaging) return null;
  if(!this.endlessPagingHelper)
   this.endlessPagingHelper = this.CreateEndlessPagingHelper();
  return this.endlessPagingHelper;
 },
 CreateEndlessPagingHelper: function() { return null; },
 GetCellFocusHelper: function() {
  if(!this.allowFocusedCell) return null;
  if(!this.cellFocusHelper)
   this.cellFocusHelper = this.CreateCellFocusHelper();
  return this.cellFocusHelper;
 },
 CreateCellFocusHelper: function() { return null; },
 GetStyleHelper: function() {
  if(!this.styleHelper)
   this.styleHelper = this.CreateStyleHelper(this);
  return this.styleHelper;
 },
 CreateStyleHelper: function() { return new GridStyleHelper(this); },
 GetLayoutHelper: function() {
  if(!this.layoutHelper)
   this.layoutHelper = this.CreateLayoutHelper();
  return this.layoutHelper;
 },
 CreateLayoutHelper: function() { return new GridLayoutHelper(this); },
 GetNavigationHelper: function() {
  if(!this.navigationHelper)
   this.navigationHelper = this.CreateNavigationHelper();
  return this.navigationHelper;
 },
 CreateNavigationHelper: function() { },
 GetCallbackHelper: function() {
  if(!this.callbackHelper)
   this.callbackHelper = this.CreateCallbackHelper();
  return this.callbackHelper;
 },
 CreateCallbackHelper: function() { return new GridCallbackHelper(this); },
 GetFilterHelper: function() {
  if(!this.filterHelper)
   this.filterHelper = this.CreateFilterHelper();
  return this.filterHelper;
 },
 CreateFilterHelper: function() { return new ASPx.GridFilterHelper(this); },
 GetToolbarHelper: function() {
  if(!this.toolbarHelper)
   this.toolbarHelper = this.CreateToolbarHelper();
  return this.toolbarHelper;
 },
 CreateToolbarHelper: function() { return new ASPx.GridToolbarHelper(this); },
 Invalidate: function() {
  this.InvalidateLayout();
 },
 InvalidateLayout: function() {
  this.GetLayoutHelper().Invalidate();
  var navigationHelper = this.GetNavigationHelper();
  if(navigationHelper)
   navigationHelper.Invalidate();
  this.serverVisibleIndicesHash = null;
 },
 IsLastCallbackProcessedAsEndless: function() {
  var helper = this.GetEndlessPagingHelper();
  return helper && helper.endlessCallbackComplete;
 },
 UpdateScrollableControls: function() {
  var helper = this.GetScrollHelper();
  if(helper)
   helper.Update();
 },
 SetHeight: function(height) {
  var mainElemnt = this.GetMainElement();
  if(!ASPx.IsExistsElement(mainElemnt)) return;
  var scrollHelper = this.GetScrollHelper();
  if(scrollHelper)
   scrollHelper.SetHeight(height);
 },
 SetHeadersClientEvents: function() {
  var grid = this;
  var attachMouseDown = function(headerCell) { 
   ASPx.Evt.AttachEventToElement(headerCell, ASPx.TouchUIHelper.touchMouseDownEventName, function(e) { 
    grid.HeaderMouseDown(headerCell, e);
   }, true);
  };
  this.AttachEventToHeaderCells(attachMouseDown, false);
  this.AttachEventToHeaderCells(attachMouseDown, true);
  this.AttachEventToCustomizationWindowHeaderCells(attachMouseDown);
 },
 AttachEventToCustomizationWindowHeaderCells: function(attachFunc) {
  var custWindow = this.GetCustomizationWindowElement();
  if(!custWindow) return;
  var headers = this.GetCustomizationWindowHeaders();
  for(var i = 0; i < headers.length; i++)
   attachFunc(headers[i]);
 },
 AttachEventToHeaderCells: function(attachFunc, inGroupPanel) {
  for(var i = 0; i < this.columns.length; i++) {
   var header = this.GetHeader(this.columns[i].index, inGroupPanel);
   if(header) 
    attachFunc(header);
  }
 },
 GetCustomizationWindowHeaders: function() {
  return ASPx.GetNodesByPartialClassName(this.GetCustomizationWindowElement(), ASPx.GridViewConsts.HeaderCellCssClass);
 },
 UpdatePostBackSyncInput: function(isChangedNotification) {
  if(!ASPx.IsExists(this.stateObject.lastMultiSelectIndex)) return;
  var selectedIndex = isChangedNotification ? -1 : this.lastMultiSelectIndex; 
  this.stateObject.lastMultiSelectIndex = selectedIndex;
 },
 ApplyPostBackSyncData: function() {
  if(!ASPx.IsExists(this.stateObject.lastMultiSelectIndex)) return;
  this.lastMultiSelectIndex = this.stateObject.lastMultiSelectIndex;
 },
 EnsureVisibleRowFromServer: function() {
  if(this.scrollToRowIndex < 0) return;
  this.MakeRowVisible(this.scrollToRowIndex);
  this.scrollToRowIndex = -1;
 },
 MakeRowVisible: function(visibleIndex) { },
 EnsureRowHotTrackItems: function() {
  if(this.rowHotTrackStyle == null) 
   return;
  var list = [ ];
  var rowIndices = this.GetRowHotTrackItemsRowIndices();
  for(var i = rowIndices.start; i < rowIndices.start + rowIndices.end; i++)
   list.push(this.GetDataItemIDPrefix() + i);
  if(list.length > 0)
   ASPx.AddHoverItems(this.name, [ [ [this.rowHotTrackStyle[0]], [this.rowHotTrackStyle[1]],  list, this.GetHotTrackItemPostfixes() ] ]);
 },
 GetHotTrackItemPostfixes: function(){ return null; },
 GetRowHotTrackItemsRowIndices: function() {
  return {
   start: this.visibleStartIndex,
   end: this.pageRowCount
  };
 },
 GetFooterCellIndex: function(element) {
  element = this.GetFooterCellElement(element, ASPx.GridViewConsts.FooterRowID);
  if(element == null)
   return -1;
  var matrix = this.GetHeaderMatrix();
  var leafIndex = element.cellIndex - this.GetFooterIndentCount(element.parentNode);
  var index = matrix.GetLeafIndices()[leafIndex];
  return ASPx.IsExists(index) ? index : -1;
 },
 GetGroupFooterCellIndex: function(element) {
  element = this.GetFooterCellElement(element, ASPx.GridViewConsts.GroupFooterRowID);
  return element != null ? this.GetColumnIndexByDataCell(element) : -1;
 },
 GetColumnIndexByDataCell: function(element) {
  return -1;
 },
 GetFooterCellElement: function(element, footerRowID) {
  var footerRowName = this.name + "_" + footerRowID;
  while(element.parentNode.id.indexOf(footerRowName) === -1) {
   if(element.tagName == "BODY")
    return null;
   element = element.parentElement;
  }
  return element;
 },
 GetFooterIndentCount: function(footerElement) {
  return ASPx.GetChildNodesByClassName(footerElement, "dxgvIndentCell").length;
 },
 Focus: function() {
  if(this.kbdHelper)
   this.kbdHelper.Focus();
 },
 PerformCallback: function(args, onSuccess){
  if(!ASPx.IsExists(args)) args = "";
  this.gridCallBack([ASPxClientGridViewCallbackCommand.CustomCallback, args], onSuccess);
 },
 GetValuesOnCustomCallback: function(args, onCallBack) {
  this.gridFuncCallBack([ASPxClientGridViewCallbackCommand.CustomValues, args], onCallBack);
 },
 GotoPage: function(pageIndex){
  if(this.useEndlessPaging)
   return;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.GotoPage, pageIndex]);
 },
 GetPageIndex: function(){
  return this.pageIndex;
 },
 GetPageCount: function(){
  return this.pageCount;
 },
 NextPage: function(){
  this.gridCallBack([ASPxClientGridViewCallbackCommand.NextPage]);
 },
 PrevPage: function(focusBottomRow){
  if(!this.useEndlessPaging)
   this.gridCallBack([ASPxClientGridViewCallbackCommand.PreviousPage, focusBottomRow ? "T" : "F"]);
 },
 IsLastPage: function() {
  return this.pageIndex === this.pageCount - 1;
 },
 GetItemKey: function(visibleIndex) {
  var arrayIndex = visibleIndex - this.visibleStartIndex;
  if(arrayIndex < 0 || arrayIndex > this.keys.length - 1) 
   return null;
  var key = this.keys[arrayIndex];
  if(key == "/^DXN")
   key = null;
  return key;
 },   
 GetDataItemVisibleIndices: function(includeDeleted, fromAPI) {
  var helper = this.GetBatchEditHelper();
  if(helper) {
   includeDeleted |= helper.GetHighlightDeletedItems() && !fromAPI;
   var keys = helper.GetRecordKeys(!includeDeleted);
   return keys.map(function(key) { return this.ConvertKeyToVisibleIndex(key); }.bind(this));
  }
  return this.GetDataItemVisibleIndicesCore();
 },
 GetDataItemVisibleIndicesCore: function() {
  var indices = this.GetCurrentPageIndices();
  return indices.filter(function(index) { return this.GetDataItem(index); }.bind(this)); 
 },
 GetRecordKeys: function(includeDeleted) { 
  var indices = this.GetDataItemVisibleIndices(includeDeleted);
  return indices.map(this.ConvertVisibleIndexToKey.bind(this));
 },
 ConvertVisibleIndexToKey: function(visibleIndex) { 
  if(!ASPx.IsExists(visibleIndex))
   return null;
  if(visibleIndex < 0)
   return visibleIndex;
  var key = this.GetItemKey(visibleIndex);
  if(ASPx.IsExists(key))
   return key;
  var helper = this.GetBatchEditHelper();
  return helper && helper.GetSavedKeyByVisibleIndex(visibleIndex);
 },
 ConvertKeyToVisibleIndex: function(key) {
  this.EnsureServerVisibleIndicesHash();
  if(ASPx.IsExists(this.serverVisibleIndicesHash[key]))
   return this.serverVisibleIndicesHash[key];
  var helper = this.GetBatchEditHelper();
  if(helper) {
   var index = parseInt(key);
   if(!isNaN(index) && index < 0)
    return index;
   else
    return helper.GetSavedVisibleIndexByKey(key);
  }
  return null;
 },
 EnsureServerVisibleIndicesHash: function() {
  if(this.serverVisibleIndicesHash)
   return;
  this.serverVisibleIndicesHash = { };
  var indices = this.GetCurrentPageIndices();
  for(var i = 0; i < indices.length; i++) {
   var visibleIndex = indices[i];
   var key = this.GetItemKey(visibleIndex);
   this.serverVisibleIndicesHash[key] = visibleIndex;
  }
 },
 GetCurrentPageIndices: function() {
  var indices = [ ];
  var startIndex = this.GetTopVisibleIndex();
  var endIndex = startIndex + this.pageRowCount;
  for(var i = startIndex; i < endIndex; i++)
   indices.push(i);
  return indices;
 },
 StartEditItem: function(visibleIndex, columnIndex) {
  this.StartEditItemByKey(this.ConvertVisibleIndexToKey(visibleIndex), columnIndex);
 },
 StartEditItemByKey: function(key, columnIndex) {
  if(!this.HasKeyField() || key === null) 
   return;
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   batchEditHelper.StartEditCell(key, columnIndex);
  else
   this.gridCallBack([ASPxClientGridViewCallbackCommand.StartEdit, key]);
 },
 IsEditing: function() { return this.editState > 0; },
 IsNewItemEditing: function() { return this.editState > 1; },
 IsEditingItem: function(visibleIndex) { return this.editItemVisibleIndex === visibleIndex; },
 IsNewRowAtBottom: function() { return this.editState == 3; },
 UpdateEdit: function(){
  this._updateEdit();
 },
 CancelEdit: function(visibleIndex) {
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper) {
   var recordKey = ASPx.IsExists(visibleIndex) && visibleIndex !== this.InvalidItemIndex ? this.ConvertVisibleIndexToKey(visibleIndex) : null;
   batchEditHelper.CancelEdit(recordKey);
  } else
   this.gridCallBack([ASPxClientGridViewCallbackCommand.CancelEdit]);
 },
 AddNewItem: function() {
  if(this.allowBatchEditing)
   this.batchEditApi.AddNewItem();
  else 
   this.AddNewItemOnServer();
 },
 AddNewItemOnServer: function() {
  if(!this.HasKeyField()) return;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.AddNewRow]);
 },
 DeleteItem: function(visibleIndex) {
  if(this.allowBatchEditing)
   this.batchEditApi.DeleteItem(visibleIndex);  
  else
   this.DeleteItemByKey(this.GetItemKey(visibleIndex));
 },
 RecoverItem: function(visibleIndex){
  if(this.allowBatchEditing)
   this.batchEditApi.RecoverItem(visibleIndex);  
 },
 DeleteItemByKey: function(key) {
  if(this.allowBatchEditing)
   this.batchEditApi.DeleteItemByKey(key);
  else
   this.DeleteItemByKeyOnServer(key);
 },
 DeleteItemByKeyOnServer: function(key) {
  if(!this.HasKeyField() || key === null) 
   return;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.DeleteRow, key]);
 },
 HasKeyField: function() {
  var result = this.keys.length > 0 || this.pageRowCount === 0;
  if(!result)
   alert(this.RequireKeyFieldNameText);
  return result;
 },
 Refresh: function(){
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   batchEditHelper.CancelEdit();
  this.gridCallBack([ASPxClientGridViewCallbackCommand.Refresh]);
 },
 ApplyFilter: function(expression){
  expression = expression || "";
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ApplyFilter, expression]);
 },
 ClearFilter: function () {
  this.GetFilterHelper().ClearFilterEditorsState();
  this.ApplyFilter();
 },
 GetAutoFilterEditor: function(column) { 
  var index = this._getColumnIndexByColumnArgs(column);
  if(!ASPx.IsExists(index)) return null;
  return ASPx.GetControlCollection().Get(this.name + "_DXFREditorcol" + index);
 },
 AutoFilterByColumn: function(column, val){
  var index = this._getColumnIndexByColumnArgs(column);
  if(!ASPx.IsExists(index)) return;
  if(!ASPx.IsExists(val)) val = "";  
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ApplyColumnFilter, index, val]);
 },
 ApplyHeaderFilterByColumn: function() {
  var popup = this.GetHeaderFilterPopup();
  popup.Hide();
  var helper = this.GetFilterHelper();
  var column = helper.GetHeaderFilterPopupRelatedColumn();
  if(column) {
   var state = helper.GetHeaderFilterCallbackState(column.index);
   this.gridCallBack([ASPxClientGridViewCallbackCommand.ApplyHeaderColumnFilter, column.index, ASPx.Json.ToJson(state)]);
  }
 },
 SortBy: function(column, sortOrder, reset, sortIndex){
  if(this.RaiseColumnSorting(this._getColumnObjectByArg(column))) return;
  column = this._getColumnIndexByColumnArgs(column);
  if(!ASPx.IsExists(sortIndex)) sortIndex = "";
  if(!ASPx.IsExists(sortOrder)) sortOrder = "";
  if(!ASPx.IsExists(reset)) reset = true;
  this.gridCallBack([ASPxClientGridViewCallbackCommand.Sort, column, sortIndex, sortOrder, reset]);
 },
 GroupBy: function(column, groupIndex, sortOrder){
  if(this.RaiseColumnGrouping(this._getColumnObjectByArg(column))) return;
  column = this._getColumnIndexByColumnArgs(column);
  if(!ASPx.IsExists(groupIndex)) groupIndex = "";
  if(!ASPx.IsExists(sortOrder)) sortOrder = "ASC";
  this.gridCallBack([ASPxClientGridViewCallbackCommand.Group, column, groupIndex, sortOrder]);
 },
 Ungroup: function(column){
  column = this._getColumnIndexByColumnArgs(column);
  this.GroupBy(column, -1);
 },
 ExpandAll: function(){
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ExpandAll]);
 },
 CollapseAll: function(){
  this.gridCallBack([ASPxClientGridViewCallbackCommand.CollapseAll]);
 },
 MoveColumn: function(column, columnMoveTo, direction, moveToGroup, moveFromGroup){
  if(!ASPx.IsExists(column)) return;
  if(!ASPx.IsExists(columnMoveTo)) columnMoveTo = -1;
  if(!ASPx.IsExists(moveToGroup)) moveToGroup = false;
  if(!ASPx.IsExists(moveFromGroup)) moveFromGroup = false;
  if(moveToGroup) {
   if(this.RaiseColumnGrouping(this._getColumnObjectByArg(column))) return;
  }
  direction = this.getColumnMoveDirection(direction);
  column = this._getColumnIndexByColumnArgs(column);
  this.MoveColumnCore(column, columnMoveTo, direction, moveToGroup, moveFromGroup);
 },
 MoveColumnCore: function(sourceIndex, targetIndex, direction, moveToGroup, moveFromGroup) {
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ColumnMove, sourceIndex, targetIndex, direction, moveToGroup, moveFromGroup]);
 },
 getColumnMoveDirection: function(direction){
  if(!ASPx.IsExists(direction))
   return ASPxClientGridColumnMovingTargetPosition.Left;
  if(direction === false)
   return ASPxClientGridColumnMovingTargetPosition.Left;
  if(direction === true)
   return ASPxClientGridColumnMovingTargetPosition.Right;
  if(ASPx.IsNumber(direction))
   return direction;
  return ASPxClientGridColumnMovingTargetPosition.Left;
 },
 IsCustomizationWindowVisible: function(){
  var custWindow = this.GetCustomizationWindow();
  return custWindow != null && custWindow.IsVisible();
 },
 ShowCustomizationWindow: function(showAtElement, accessibleFocusElement){
  var custWindow = this.GetCustomizationWindow();
  if(!custWindow) return;
  if(!showAtElement) showAtElement = this.GetMainElement();
  if(this.accessibilityCompliant && accessibleFocusElement)
   custWindow.accessibleFocusElement = accessibleFocusElement;
  custWindow.ShowAtElement(showAtElement);
 },
 HideCustomizationWindow: function(){
  var custWindow = this.GetCustomizationWindow();
  if(custWindow != null) custWindow.Hide();
 },
 ShowCustomizationDialog: function() { },
 ExportTo: function(format) {
  this.gridPostBack([ASPxClientGridViewCallbackCommand.Export, format]);
 },
 GetSelectedFieldValues: function(fieldNames, onCallBack) {
  this.gridFuncCallBack([ASPxClientGridViewCallbackCommand.SelFieldValues, fieldNames], onCallBack);
 },
 GetSelectedKeysOnPage: function() {
  var keys = [];
  for(var i = 0; i < this.pageRowCount; i++) {
   if(this._isRowSelected(this.visibleStartIndex + i))
    keys.push(this.keys[i]);
  }
  return keys; 
 },
 GetItemValues: function(visibleIndex, fieldNames, onCallBack) {
  this.gridFuncCallBack([ASPxClientGridViewCallbackCommand.RowValues, visibleIndex, fieldNames], onCallBack);
 },
 GetPageItemValues: function(fieldNames, onCallBack) {
  this.gridFuncCallBack([ASPxClientGridViewCallbackCommand.PageRowValues, fieldNames], onCallBack);
 },
 GetVisibleItemsOnPage: function() {
  var batchEditHelper = this.GetBatchEditHelper();
  if(batchEditHelper)
   return batchEditHelper.GetVisibleRecordsOnPageCount();
  return this.pageRowCount;
 },
 GetTopVisibleIndex: function() {
  return this.visibleStartIndex;
 },
 GetColumnsCount: function() {
  return this.GetColumnCount();
 },
 GetColumnCount: function() {
  return this._getColumnCount();
 },
 GetColumn: function(index) {
  return this._getColumn(index);
 },
 GetColumnById: function(id) {
  return this._getColumnById(id);
 },
 GetColumnByField: function(fieldName) {
  return this._getColumnByField(fieldName);
 },
 GetEditor: function(column) {
  var columnObject = this._getColumnObjectByArg(column);
  return columnObject != null ? this.GetEditorByColumnIndex(columnObject.index) : null;
 },
 FocusEditor: function(column) {
  var editor = this.GetEditor(column);
  if(editor && editor.SetFocus) {
   editor.SetFocus();  
  }
 },
 GetEditValue: function(column) {
  var editor = this.GetEditor(column);
  return editor != null && editor.enabled ? editor.GetValue() : null;
 },
 SetEditValue: function(column, value) {
  var editor = this.GetEditor(column);
  if(editor != null && editor.enabled) {
   editor.SetValue(value);
  }
 },
 ShowFilterControl: function() {
  this.PreventCallbackAnimation();
  this.gridCallBack([ASPxClientGridViewCallbackCommand.ShowFilterControl]);
 },
 CloseFilterControl: function() {
  this.PreventCallbackAnimation();
  this.HideFilterControlPopup();
  this.gridCallBack([ASPxClientGridViewCallbackCommand.CloseFilterControl]);
 },
 HideFilterControlPopup: function() {
  var popup = this.GetFilterControlPopup();
  if(popup) {
   popup.Hide();
   if(this.accessibilityCompliant) {
    var needToStoreFocusTreeLine = !this.accessibilityFocusTreeLine && ASPx.GetIsParent(this.GetMainElement(), ASPx.GetActiveElement());
    if(needToStoreFocusTreeLine)
     this.accessibilityFocusTreeLine = ASPx.RestoreFocusHelper.getFocusTreeLine(this);
   }
  }
 },
 ApplyFilterControl: function() {
  this.PreventCallbackAnimation();
  var fc = this.GetFilterControl();
  if(fc == null) return;
  if(!this.callBacksEnabled)
   this.HideFilterControlPopup();
  if(!fc.isApplied)
   fc.Apply(this);
 },
 SetFilterEnabled: function(isFilterEnabled) {
  this.gridCallBack([ASPxClientGridViewCallbackCommand.SetFilterEnabled, isFilterEnabled]);
 },
 GetVerticalScrollPosition: function() { return 0; },
 SetVerticalScrollPosition: function(value) { },
 RaiseSelectionChangedOutOfServer: function() {
  this.RaiseSelectionChanged(-1, false, false, true);
 },
 RaiseSelectionChanged: function(visibleIndex, isSelected, isAllRecordsOnPage, isChangedOnServer) {
  if(!this.SelectionChanged.IsEmpty()){
   var args = this.CreateSelectionEventArgs(visibleIndex, isSelected, isAllRecordsOnPage, isChangedOnServer);
   this.SelectionChanged.FireEvent(this, args);
   if(args.processOnServer) {
    this.gridCallBack([ASPxClientGridViewCallbackCommand.Selection]);
   }
  }
  return false; 
 },
 CreateSelectionEventArgs: function(visibleIndex, isSelected, isAllRecordsOnPage, isChangedOnServer){
  return null;
 },
 RaiseFocusedItemChangedOutOfServer: function() { 
  this.RaiseFocusedItemChanged(true); 
 },
 RaiseFocusedItemChanged: function(isChangedOnServer) { return false; },
 RaiseItemFocusing: function(visibleIndex, htmlEvent) { return false; },
 RaiseColumnSorting: function(column) {
  if(!this.ColumnSorting.IsEmpty()){
   var args = this.CreateColumnCancelEventArgs(column);
   this.ColumnSorting.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 CreateColumnCancelEventArgs: function(column){
  return null;
 },
 RaiseColumnGrouping: function(column) {
  if(!this.ColumnGrouping.IsEmpty()){
   var args = this.CreateColumnCancelEventArgs(column);
   this.ColumnGrouping.FireEvent(this, args);
   return args.cancel;
  }
  return false; 
 },
 RaiseItemClick: function(visibleIndex, htmlEvent) {
  return false; 
 },
 RaiseItemDblClick: function(visibleIndex, htmlEvent) {
  return false; 
 },
 RaiseCustomizationWindowCloseUp: function() {
  if(!this.CustomizationWindowCloseUp.IsEmpty()){
   var args = new ASPxClientEventArgs();
   this.CustomizationWindowCloseUp.FireEvent(this, args);
  }
  return false; 
 },
 RaiseColumnMoving: function(targets) {
  return false;
 },
 RaiseToolbarItemClick: function(toolbarInfo, item) {
  if(this.ToolbarItemClick.IsEmpty())
   return false;
  var args = new ASPxClientGridToolbarItemClickEventArgs(toolbarInfo.index, toolbarInfo.name, item, false);
  this.ToolbarItemClick.FireEvent(this, args);
  if(!args.handled && args.processOnServer) {
   this.GetToolbarHelper().ProcessCustomToolbarItemClickOnServer(args.usePostBack);
   return true;
  }
  return args.handled;
 },
 RaiseBatchEditStartEditing: function(visibleIndex, column, rowValues) { return null; },
 RaiseBatchEditEndEditing: function(visibleIndex, rowValues) { return null; },
 RaiseBatchEditItemValidating: function(visibleIndex, validationInfo) { return null; },
 RaiseBatchEditConfirmShowing: function(requestTriggerID) { return false; },
 RaiseBatchEditTemplateCellFocused: function(columnIndex) { return false; },
 RaiseBatchEditChangesSaving: function(valuesInfo) { return false; },
 RaiseBatchEditChangesCanceling: function(valuesInfo) { return false; },
 RaiseBatchEditItemInserting: function(visibleIndex) { return false; },
 RaiseBatchEditItemDeleting: function(visibleIndex, itemValues) { return false; },
 RaiseBatchEditItemRecovering: function(visibleIndex, itemValues) { return false; },
 RaiseFocusedCellChanging: function(info) {
  if(!this.FocusedCellChanging.IsEmpty()){   
   var key = info.recordKey;
   var cellInfo = this.CreateCellInfo(this.ConvertKeyToVisibleIndex(key), this.GetColumn(info.columnIndex), key);
   var args = this.CreateFocusedCellChangingArgs(cellInfo);
   this.FocusedCellChanging.FireEvent(this, args);
   return args.cancel;
  }
  return false;   
 },
 CreateCellInfo: function(visibleIndex, column, key) { return null; },
 CreateFocusedCellChangingArgs: function(cellInfo) { return null; },
 RaiseInternalCheckBoxClick: function(visibleIndex) {
  if(!this.InternalCheckBoxClick.IsEmpty()){
   var args = {"visibleIndex": visibleIndex, cancel: false};
   this.InternalCheckBoxClick.FireEvent(this, args);
   return args.cancel;
  }
  return false;
 },
 UA_AddNew: function() {
  this.AddNewItem();
 },
 UA_StartEdit: function(visibleIndex) {
  this.StartEditItem(visibleIndex);
 },
 UA_Delete: function(visibleIndex) {
  this.DeleteGridItem(visibleIndex);
 },
 UA_Recover: function(visibleIndex) {
  this.RecoverItem(visibleIndex);
 },
 UA_UpdateEdit: function() {
  this.UpdateEdit();
 },
 UA_CancelEdit: function(visibleIndex) {
  this.CancelEdit(visibleIndex);
 },
 UA_CustomButton: function(id, visibleIndex) {
  this.CommandCustomButton(id, visibleIndex);
 },
 UA_Select: function(visibleIndex) {
  if(!this.lookupBehavior || this.allowSelectByItemClick){
   var selected = this.allowSelectSingleRowOnly || !this._isRowSelected(visibleIndex);
   this.SelectItem(visibleIndex, selected);
  }
 },
 UA_ClearFilter: function() {
  this.ClearFilter();
 },
 UA_ApplySearchFilter: function() {
  this.ApplySearchFilterFromEditor();
 },
 UA_ClearSearchFilter: function() {
  var editor = this.GetSearchEditor();
  if(editor)
   editor.SetValue(null);
  this.ApplySearchFilterFromEditor();
 },
 ApplySearchFilterFromEditor: function() {
  this.GetFilterHelper().ApplySearchFilterFromEditor(this.GetSearchEditor());
 },
 ChangeCellInitialClass: function(cell, className, add) { this.GetStyleHelper().ChangeCellInitialClass(cell, className, add); },
 OnDispose: function() { 
  if(this.filterHelper)
   this.filterHelper.OnDispose();
  ASPxClientControl.prototype.OnDispose.call(this);
 },
});
ASPxClientGridBase.Cast = ASPxClientControl.Cast;
var GridCallbackHelper = ASPx.CreateClass(null, {
 constructor: function(grid) {
  this.grid = grid;
  this.funcCallbackInfoList = [ ];
  this.postbackRequestCount = 0;
 },
 GetAllowDelete: function() { return this.grid.allowDelete; },
 GetAllowEdit: function() { return this.grid.allowEdit; },
 GetAllowInsert: function() { return this.grid.allowInsert; },
 CanSendCallback: function() { return this.grid.callBack && this.grid.callBacksEnabled; },
 GetEditorValues: function() { return this.grid.GetEditorValues(); },
 GetSelectionState: function() { return this.grid.GetSelectedState(); },
 GetKeyValues: function() { return this.grid.GetKeyValues(); },
 GetFocusedRowState: function() { return this.grid.stateObject.focusedRow; },
 GetToolbarState: function() { return this.grid.GetToolbarHelper().GetCallbackState(); },
 GetRequestCount: function() { return this.grid.requestCount; },
 ResetUserChangedSelection: function() { 
  this.grid.userChangedSelection = false; 
 },
 GetTotalRequestCount: function() { return this.GetRequestCount() + this.postbackRequestCount; },
 CreateGridCallback: function(command, args, callbackHandler) {
  this.grid.CreateCallback(args, command, callbackHandler);
 },
 CreateGridPostback: function(args, preventConvertToUpdatePanelCallback) {
  this.grid.SendPostBack(args, preventConvertToUpdatePanelCallback);
 },
 OnBeforeCallbackOrPostBack: function() {
  this.grid.OnBeforeCallbackOrPostBack(); 
 },
 OnBeforeCallback: function(command) { this.grid.OnBeforeCallback(command); },
 SendRequest: function(args, callbackHandler) {
  var command = this.GetCorrectedCommand(args);
  if(!this.ValidateCommand(command))
   return;
  this.OnBeforeCallbackOrPostBack();
  if(this.CanSendCallback())
   this.SendCallback(command, args, callbackHandler);
  else
   this.SendPostback(args);
 },
 SendCallback: function(command, args, callbackHandler) {
  this.OnBeforeCallback(command);
  var callbackState = this.GetGridCallbackState();
  this.ResetUserChangedSelection();
  this.SendCallbackCore(command, args, callbackState, callbackHandler);
 },
 SendFuncCallback: function(args, onCallBack) {
  var callbackState = this.GetGridCallbackState();
  callbackState.push([ "FB", this.GetFuncCallBackIndex(onCallBack) ]);
  this.SendCallbackCore("FUNCTION", args, callbackState);
 },
 SendCallbackCore: function(command, commandArgs, callbackState, callbackHandler) {
  callbackState.push([ "GB", this.SerializeCallbackArgs(commandArgs) ]);
  this.CreateGridCallback(command, this.FormatCallbackState(callbackState), callbackHandler);
 },
 SendPostback: function(args) {
  this.postbackRequestCount++;
  this.CreateGridPostback(this.SerializeCallbackArgs(args), this.IsExportPostback(args));
 },
 ValidateCommand: function(command) {
  if(command === ASPxClientGridViewCallbackCommand.DeleteRow && !this.GetAllowDelete())
   return false;
  if(command === ASPxClientGridViewCallbackCommand.StartEdit && !this.GetAllowEdit())
   return false;
  if(command === ASPxClientGridViewCallbackCommand.AddNewRow && !this.GetAllowInsert())
   return false;
  return true;
 },
 GetCorrectedCommand: function(args) {
  if(args.length === 0) return "";
  var command = args[0];
  if(args.length > 1 && command === ASPxClientGridViewCallbackCommand.ColumnMove) {
   if(args[args.length - 1])
    command = ASPxClientGridViewCallbackCommand.UnGroup;
   if(args[args.length - 2])
    command = ASPxClientGridViewCallbackCommand.Group;
  }
  return command;
 },
 IsExportPostback: function(args) {
  if(!ASPx.Ident.IsArray(args) || args.length === 0)
   return false;
  return args[0] == ASPxClientGridViewCallbackCommand.Export || args[1] == ASPxClientGridViewCallbackCommand.Export;
 },
 GetGridCallbackState: function() {
  return [
   [ "EV", this.GetEditorValues() ],
   [ "SR", this.GetSelectionState() ],
   [ "KV", this.GetKeyValues() ],
   [ "FR", this.GetFocusedRowState() ],
   [ "CT", this.GetToolbarState() ]
  ];
 },
 GetFuncCallBackIndex: function(onCallBack) {
  var info = { date: new Date(), callback: onCallBack };
  for(var i = 0; i < this.funcCallbackInfoList.length; i ++) {
   if(this.funcCallbackInfoList[i] === null) {
    this.funcCallbackInfoList[i] = info;
    return i;
   }
  }
  this.funcCallbackInfoList.push(info);
  return this.funcCallbackInfoList.length - 1;
 },
 GetFuncCallBackInfo: function(index) {
  if(index < 0 || index >= this.funcCallbackInfoList.length) 
   return null;
  var result = this.funcCallbackInfoList[index];
  this.funcCallbackInfoList[index] = null;
  return result;
 },
 HasWaitedFuncCallbacks: function() {
  return this.funcCallbackInfoList.filter(function(i) { return i !== null; }).length > 0;
 },
 HasWaitedFuncCallbacksFromInterval: function(timeout) {
  var date = new Date();
  for(var i = 0; i < this.funcCallbackInfoList.length; i++) {
   var info = this.funcCallbackInfoList[i];
   if(info && (date - info.date) < timeout)
    return true;
  }
  return false;
 },
 FormatCallbackState: function(callbackState) {
  var result = [ ];
  for(var i = 0; i < callbackState.length; i++) {
   var stateItem = callbackState[i];
   if(!stateItem || stateItem.length !== 2)
    continue;
   var stateKey = stateItem[0];
   var stateValue = stateItem[1];
   if(ASPx.IsExists(stateValue) && stateValue !== "") {
    var stateValueString = stateValue.toString();
    result.push(stateKey);
    result.push("|");
    result.push(stateValueString.length);
    result.push(";");
    result.push(stateValueString);
    result.push(";");
   }
  }
  return result.join("");
 },
 SerializeCallbackArgs: function(args) {
  if(!ASPx.Ident.IsArray(args) || args.length === 0)
   return "";
  var result = [ ];
  for(var i = 0; i < args.length; i++) {
   var item = args[i].toString();
   result.push(item.length);
   result.push("|");
   result.push(item);
  }
  return result.join("");
 }
});
var GridStyleHelper = ASPx.CreateClass(ASPx.GridStyleHelperBase, {
 SelectedItemKey: "sel",
 FocusedItemKey: "fi",
 constructor: function(grid) {
  this.grid = grid;
 },
 GetStyles: function() { return this.grid.styleInfo; },
 GetSelectedItemStyle: function() { return this.GetStyleInfo(this.SelectedItemKey); },
 GetFocusedItemStyle: function() { return this.GetStyleInfo(this.FocusedItemKey); },
 IsSelectedItemStyle: function(style) { return this.CheckStyleInfoByKey(style, this.SelectedItemKey); },
 IsFocusedItemStyle: function(style) { return this.CheckStyleInfoByKey(style, this.FocusedItemKey); },
});
var ASPxClientGridColumnBase = ASPx.CreateClass(null, {
 constructor: function(prop) {
  this.index =   ASPx.IsExists(prop[0]) ? prop[0] : -1;
  this.visible =    ASPx.IsExists(prop[1]) ?  !!prop[1] : true;
  this.name =    ASPx.IsExists(prop[2]) ? prop[2] : "";
  this.fieldName =  ASPx.IsExists(prop[3]) ? prop[3] : "";
  this.allowSort =  ASPx.IsExists(prop[4]) ?  !!prop[4] : true;
  this.HFMode =     ASPx.IsExists(prop[5]) ? prop[5] : 1;
  this.sortIndex =  ASPx.IsExists(prop[6]) ? prop[6] : -1;
  this.sortOrder =  ASPx.IsExists(prop[7]) ? prop[7] : ASPx.GridSortOrder.None;
  this.id = this.name;
 }
});
var GridLayoutHelper = ASPx.CreateClass(null, { 
 constructor: function(grid) {
  this.grid = grid;
 },
 GetDataItemVisibleIndices: function(includeDeleted) { return this.grid.GetDataItemVisibleIndices(includeDeleted); },
 Invalidate: function() { 
 },
});
var GridViewDragHelper = ASPx.CreateClass(ASPx.GridDragHelperBase, {
 constructor: function(grid) {
  this.grid = grid;
  this.targets = null;
  this.constructor.prototype.constructor.call(this);
 },
 CreateDrag: function(e, element, canDrag) {
  var drag = new ASPx.DragHelper(e, element, true);
  drag.centerClone = true;
  drag.canDrag = canDrag;  
  drag.grid = this.grid;
  drag.ctrl = e.ctrlKey;
  drag.shift = e.shiftKey;
  drag.onDragDivCreating = this.OnDragDivCreating;
  drag.onDoClick = this.OnDoClick;
  drag.onCloneCreating = this.OnCloneCreating;
  drag.onEndDrag = this.OnEndDrag;
  drag.onCancelDrag = this.OnCancelDrag;
  this.OnDragCreated(true);
  return drag;
 },
 GetActiveTargets: function() { 
  if(this.targets && this.targets.list)
   return this.targets.list;
  return [ ];
 },
 GetScrollHelper: function() { return this.grid.GetScrollHelper(); },
 GetCustomizationWindowElement: function() { return this.grid.GetCustomizationWindowElement(); },
 GetHeaderLeaf: function(columnIndex, isLeft){ return this.grid.GetHeaderMatrix().GetLeaf(columnIndex, isLeft, false); },
 GetHeaderLevel: function(columnIndex){ return this.grid.GetHeaderMatrix().GetColumnLevel(columnIndex); },
 NeedScrollOnDrag: function(isHorzDrag) { 
  var hasFixedColumns = this.grid.GetFixedColumnsHelper && this.grid.GetFixedColumnsHelper();
  return ASPx.GridDragHelperBase.prototype.NeedScrollOnDrag.call(this, isHorzDrag) || hasFixedColumns; 
 },
 PrepareTargetHeightFunc: function() {
  GridViewDragHelper.Target_GetElementHeight = null;
  if(this.grid.allowChangeColumnHierarchy)
   return;
  var headerRowCount = this.grid.GetHeaderMatrix().GetRowCount();
  if(headerRowCount > 0) {
   var row = this.grid.GetHeaderRow(headerRowCount - 1);
   var headerBottom = ASPx.GetAbsoluteY(row) + row.offsetHeight;
   GridViewDragHelper.Target_GetElementHeight = function() {
    return headerBottom - this.absoluteY;
   };
  }
 },
 CreateTargets: function(drag, e) {
  if(!drag.canDrag) return;
  var grid = this.grid;
  this.PrepareTargetHeightFunc();
  var targets = new ASPx.CursorTargets(grid);
  targets.obj = drag.obj;
  targets.onTargetCreated = this.OnTargetCreated;
  targets.onTargetChanging = this.OnTargetChanging;
  targets.onTargetChanged = this.OnTargetChanged;
  targets.onTargetAllowed = this.OnHeaderTargetAllowed.aspxBind(this);
  this.targets = targets;
  var scrollLeft = null, scrollRight;
  var scrollHelper = grid.GetScrollHelper();
  var scrollableControl = scrollHelper && scrollHelper.GetHorzScrollableControl();
  if(scrollableControl) {
   scrollLeft = ASPx.GetAbsoluteX(scrollableControl);
   scrollRight = scrollLeft + scrollableControl.offsetWidth;
  }
  var sourceColumn = grid.getColumnObject(drag.obj.id);
  var win = grid.GetCustomizationWindow();
  if(win && !sourceColumn.inCustWindow)
   this.AddDragDropTarget(targets, win.GetWindowClientTable(-1));
  for(var i = 0; i < grid.columns.length; i++) {
   var column = grid.columns[i];
   for(var grouped = 0; grouped <= 1; grouped++) {
    var targetElement = grid.GetHeader(column.index, !!grouped);
    if(!targetElement)
     continue;
    if(this.IsValidColumnDragDropTarget(drag.obj, targetElement, sourceColumn, column))
     this.AddDragDropTarget(targets, targetElement);  
   }
  }
  this.AddAdaptivePanelTarget(targets, grid.GetAdaptiveHeaderPanel());
  this.AddAdaptivePanelTarget(targets, grid.GetAdaptiveGroupPanel());
  this.AddDragDropTarget(targets, grid.GetGroupPanel());
  this.AddDragDropTarget(targets, ASPx.GetElementById(grid.name + this.grid.EmptyHeaderSuffix));
 },
 IsValidColumnDragDropTarget: function(sourceElement, targetElement, sourceColumn, targetColumn) {
  if(sourceColumn == targetColumn)
   return false;
  if(this.grid.allowChangeColumnHierarchy)
   return true;
  if(sourceColumn.parentIndex == targetColumn.parentIndex)
   return true;
  if(sourceColumn.parentIndex == targetColumn.index) {
   return (sourceColumn.inCustWindow || this.IsGroupingTarget(sourceElement))
    && this.grid.GetHeaderMatrix().IsLeaf(targetColumn.index);
  }
  if(this.IsParentColumn(sourceColumn.index, targetColumn.index))
   return (sourceColumn.inCustWindow || this.IsGroupingTarget(sourceElement));
  if(this.IsGroupingTarget(targetElement))
   return true;
  if(this.IsValidAdaptiveTarget(sourceElement, targetElement, sourceColumn, targetColumn))
   return true;
  return false;
 },
 AddAdaptivePanelTarget: function(targets, panel) {
  if(!panel) return;
  this.AppendAdaptivePanelDragAreas(targets, panel);
  this.AddDragDropTarget(targets, panel);
 },
 AppendAdaptivePanelDragAreas: function(targets, panel) {
  panel.dragAreas = [ ];
  var headers = this.GetAdaptivePanelHeaders(panel);
  if(headers.length === 0) 
   return;
  var rows = [ ];
  var row = [ headers[0] ];
  rows.push(row);
  for(var i = 0; i < headers.length - 1; i++) {
   var currentHeader = headers[i];
   var nextHeader = headers[i + 1];
   if(ASPx.GetAbsoluteY(currentHeader) !== ASPx.GetAbsoluteY(nextHeader)) {
    row = [ ];
    rows.push(row);
   }
   row.push(nextHeader);
  }
  for(var i = 0; i < rows.length; i++) {
   var row = rows[i];
   this.CreateDragArea(panel, row[0], targets, true);
   this.CreateDragArea(panel, row[row.length - 1], targets,  false);
  }
 },
 GetAdaptivePanelHeaders: function(panel) {
  return ASPx.GetNodesByPartialClassName(panel, ASPx.GridViewConsts.HeaderCellCssClass);
 },
 CreateDragArea: function(panel, target, targets, isLeft) {
  if(!this.ContainsTarget(targets, target)) 
   return; 
  var targetTop = ASPx.GetAbsolutePositionY(target);
  var area = { 
   target: target,
   isLeft: isLeft,
   top: targetTop,
   bottom: targetTop + target.offsetHeight,
   left: isLeft ? ASPx.GetAbsolutePositionX(panel) : ASPx.GetAbsolutePositionX(target) + target.offsetWidth,
   right: isLeft ? ASPx.GetAbsolutePositionX(target) :  ASPx.GetAbsolutePositionX(panel) + panel.offsetWidth
  };
  panel.dragAreas.push(area);
 },
 ContainsTarget: function(targets, target) {
  for(var i = 0; i < targets.list.length; i++) {
   if(targets.list[i].element == target)
    return true;
  }
  return false;
 },
 IsValidAdaptiveTarget: function(sourceElement, targetElement, sourceColumn, targetColumn) {
  this.EnsureAdaptiveTargetInfo(sourceElement, targetElement, sourceColumn, targetColumn);
  return !!targetElement.adaptiveInfo;
 },
 EnsureAdaptiveTargetInfo: function(sourceElement, targetElement, sourceColumn, targetColumn) {
  if(!this.IsAdaptiveHeaderTarget(targetElement))
   return;
  var sourceLevel = this.GetHeaderLevel(sourceColumn.index);
  var targetLevel = this.GetHeaderLevel(targetColumn.index);
  targetElement.adaptiveInfo = null;
  if(targetLevel < 0 || sourceLevel >= targetLevel)
   return;
  var brother = this.FindColumnBrother(sourceColumn, targetColumn);
  if(!brother) 
   return;
  var leftLeaf = this.GetHeaderLeaf(brother.index, true);
  var rightLeaf = this.GetHeaderLeaf(brother.index, false);  
  if(targetColumn.index === leftLeaf || targetColumn.index === rightLeaf)
   targetElement.adaptiveInfo = { brotherIndex : brother.index, brotherHasOnlyOneLeaf: leftLeaf == rightLeaf, isLeftLeaf: targetColumn.index == leftLeaf };
 },
 FindColumnBrother: function(sourceColumn, targetColumn) {
  while(targetColumn && targetColumn.parentIndex !== sourceColumn.parentIndex)
   targetColumn = this.grid.GetColumn(targetColumn.parentIndex);
  return targetColumn;
 },
 AddDragDropTarget: function(targets, element) {
  if(element)
   targets.addElement(element);
 },
 IsAdaptiveHeaderPanelVisible: function() { return ASPx.IsElementDisplayed(this.grid.GetAdaptiveHeaderPanel()); },
 IsAdaptiveGroupPanelVisible: function() { return ASPx.IsElementDisplayed(this.grid.GetAdaptiveGroupPanel()); },
 IsDataHeaderTarget: function(element) { return element && element.id.indexOf(this.grid.name + "_col") == 0; },
 IsAdaptiveHeaderTarget: function(element) { return this.IsAdaptiveHeaderPanelVisible() && this.IsDataHeaderTarget(element) && element.adaptiveMoved; },
 IsAdaptivePanelTarget: function(element) { return element && (element == this.grid.GetAdaptiveHeaderPanel() || element == this.grid.GetAdaptiveGroupPanel()); },
 IsAdaptiveGroupHeaderTarget: function(element) { return this.IsAdaptiveGroupPanelVisible() && this.IsGroupHeaderTarget(element) && element.adaptiveMoved; },
 IsGroupHeaderTarget: function(element) {
  if(!element || !element.id)
   return false;
  return element.id.indexOf(this.grid.name + "_groupcol") == 0;
 },
 IsGroupingTarget: function(element) { 
  return element == this.grid.GetGroupPanel() || this.IsGroupHeaderTarget(element) || element ==  this.grid.GetAdaptiveGroupPanel();
 },
 IsCustWindowTarget: function(element) {
  var win = this.grid.GetCustomizationWindow();
  return win && element == win.GetWindowClientTable(-1); 
 },
 AllowVerticalTargetTags: function(element){
  return this.grid.allowChangeColumnHierarchy && !this.IsGroupingTarget(element) && !this.IsCustWindowTarget(element);
 },
 OnDragDivCreating: function(drag, dragDiv) {
  var rootTable = drag.grid.GetMainElement();
  if(!dragDiv || !rootTable) return;
  dragDiv.className = rootTable.className;
  dragDiv.style.cssText = rootTable.style.cssText;
 },
 OnDoClick: function(drag) {
  window.setTimeout(function() {
   var grid = drag.grid;
   var contextMenuHelper = grid.GetContextMenuHelper && grid.GetContextMenuHelper(); 
   if(contextMenuHelper && contextMenuHelper.contextMenuActivating) {
    contextMenuHelper.contextMenuActivating = false;
    return;
   }
   if(!grid.canSortByColumn(drag.obj) || grid.InRegularCallback()) 
    return;
   grid.SortBy(grid.getColumnIndex(drag.obj.id), drag.ctrl ? "NONE" : "", !drag.shift && !drag.ctrl);
  }, 0);
 },
 OnCancelDrag: function(drag) {
  drag.grid.dragHelper.DisplayTargetImages(false);
  drag.grid.dragHelper.CancelDrag();
 },
 OnEndDrag: function(drag) {
  if(!drag.targetElement)
   return;
  var grid = drag.grid;
  var sourceElement = drag.obj;
  var targetElement = drag.targetElement;
  var sourceIndex = grid.getColumnIndex(sourceElement.id);
  var targetIndex =  grid.getColumnIndex(targetElement.id);
  var direction = drag.targetTag;
  if(grid.IsEmptyHeaderID(targetElement.id) || targetElement == grid.GetAdaptiveHeaderPanel())
   targetIndex = 0;
  if(grid.dragHelper.IsAdaptiveHeaderTarget(targetElement) && targetElement.adaptiveInfo) {
   targetIndex = targetElement.adaptiveInfo.brotherIndex;
   var isLeft = !targetElement.adaptiveInfo.brotherHasOnlyOneLeaf ? targetElement.adaptiveInfo.isLeftLeaf : isLeft;
   direction = isLeft ? ASPx.CursorTargetTag.Left : ASPx.CursorTargetTag.Right;
  }
  if(grid.rtl && direction < 2)
   direction = direction == ASPx.CursorTargetTag.Left ? ASPx.CursorTargetTag.Right : ASPx.CursorTargetTag.Left;
  grid.MoveColumn(
   sourceIndex,
   targetIndex,
   direction,
   grid.dragHelper.IsGroupingTarget(targetElement),
   grid.dragHelper.IsGroupingTarget(sourceElement)
  );
 },
 OnCloneCreating: function(clone) {
  var table = document.createElement("table");
  table.cellSpacing = 0;
  if(this.obj.offsetWidth > 0)
   table.style.width = Math.min(200, this.obj.offsetWidth) + "px";
  if(this.obj.offsetHeight > 0)
   table.style.height = this.obj.offsetHeight + "px";
  var row = table.insertRow(-1);
  clone.style.borderLeftWidth = "";
  clone.style.borderTopWidth = "";
  clone.style.borderRightWidth = "";
  row.appendChild(clone);
  table.style.opacity = 0.80;
  table.style.filter = "alpha(opacity=80)"; 
  if(ASPx.IsElementRightToLeft(this.obj))
   table.dir = "rtl";
  return table;
 },
 OnTargetCreated: function(targets, targetObj) {
  var f = GridViewDragHelper.Target_GetElementHeight;
  var h = targets.control.dragHelper;
  var el = targetObj.element;
  if(f && !h.IsCustWindowTarget(el) && !h.IsGroupingTarget(el) && !h.IsAdaptiveHeaderTarget(el) && !h.IsAdaptivePanelTarget(el))
   targetObj.GetElementHeight = f;
 },
 OnTargetChanging: function(targets) {
  if(!targets.targetElement)
   return;
  var grid = targets.control;
  var allowVerticalTags = grid.dragHelper.AllowVerticalTargetTags(targets.targetElement);
  targets.refreshTargetTag(allowVerticalTags);
  if(allowVerticalTags)
   grid.dragHelper.CorrectTargetTagOnMovingColumnFromCustWindow(targets);
  var grouping = false;
  if(targets.targetElement == grid.GetGroupPanel() || targets.targetElement == grid.GetAdaptiveGroupPanel()) {
   targets.targetTag = ASPx.CursorTargetTag.Left;
   grouping = true;
  }  
  if(grid.dragHelper.IsGroupHeaderTarget(targets.targetElement)) {
   grouping = true;
  }
  if(grouping && !grid.canGroupByColumn(targets.obj))
   targets.targetElement = null;
  if(grid.dragHelper.IsAdaptivePanelTarget(targets.targetElement)) {
   var info = grid.dragHelper.GetAdaptivePanelTargetInfo(targets, targets.targetElement);
   targets.targetTag = info.isLeftSide ? ASPx.CursorTargetTag.Left : ASPx.CursorTargetTag.Right;
   targets.targetElement = info.targetElement;
   targets.skipNeighbor = true;
  }
  if(targets.targetElement)
   grid.RaiseColumnMoving(targets);
 },
 CorrectTargetTagOnMovingColumnFromCustWindow: function(targets){
  if(!ASPx.currentDragHelper || !ASPx.currentDragHelper.obj || !targets.targetElement)
   return;
  var grid = targets.control;
  var sourceColumn = grid.getColumnObject(ASPx.currentDragHelper.obj.id);
  if(!sourceColumn || !sourceColumn.inCustWindow || !grid.GetColumnHelper().HasColumnChildren(sourceColumn.index))
   return;
  var sourceColumn = grid.getColumnObject(ASPx.currentDragHelper.obj.id);
  var targetColumn = grid.getColumnObject(targets.targetElement.id);
  if(targets.targetTag == ASPx.CursorTargetTag.Top || targets.targetTag == ASPx.CursorTargetTag.Bottom && grid.GetColumnHelper().HasColumnChildren(targetColumn.index))
   targets.refreshTargetTag(false);
 },
 GetAdaptivePanelTargetInfo: function(targets, panel) {
  var x = targets.x;
  var y = targets.y;
  for(var i = 0; i < panel.dragAreas.length; i++) {
   var dragArea = panel.dragAreas[i];
   if(x >= dragArea.left && x <= dragArea.right && y >= dragArea.top && y <= dragArea.bottom)
    return { targetElement: dragArea.target, isLeftSide: dragArea.isLeft };
  }
  return { targetElement: panel.children.length == 0 ? panel : null, isLeftSide: true };
 },
 OnTargetChanged: function(targets) {
  if(ASPx.currentDragHelper == null)
   return;
  var element = targets.targetElement;
  if(element == ASPx.currentDragHelper.obj)
   return;
  var grid = targets.control;
  grid.dragHelper.DisplayTargetImages(false);
  if(!element) {
   ASPx.currentDragHelper.targetElement = null;
   return;
  }
  ASPx.currentDragHelper.targetElement = element;
  ASPx.currentDragHelper.targetTag = targets.targetTag;
  var moveToCustWindow = grid.dragHelper.IsCustWindowTarget(element);
  if(moveToCustWindow) {
   ASPx.currentDragHelper.addElementToDragDiv(grid.GetArrowDragFieldImage());
   return;
  }
  var moveToGroup = grid.dragHelper.IsGroupingTarget(element);
  var info = grid.dragHelper.CreateTargetImagesInfo(targets, moveToGroup);
  if(!info) {
   ASPx.currentDragHelper.targetElement = null;
   return;
  }
  if(targets.skipNeighbor)
   info.neighbor = null;
  var position = grid.dragHelper.CreateTargetImagesPosition(element, info);
  grid.dragHelper.DisplayTargetImages(true, position);
 },
 CreateTargetImagesPosition: function(targetElement, info){
  if(info.side == ASPx.CursorTargetTag.Top || info.side == ASPx.CursorTargetTag.Bottom)
   return this.CreateVerticalTargetImagesPosition(targetElement, info);
  return this.CreateHorizontalTargetImagesPosition(targetElement, info);
 },
 CreateHorizontalTargetImagesPosition: function(targetElement, info){
  var left = ASPx.GetAbsoluteX(targetElement);
  var isRightSide = info.side == ASPx.CursorTargetTag.Right;
  if(targetElement == this.grid.GetGroupPanel() || targetElement == this.grid.GetAdaptiveHeaderPanel() || targetElement == this.grid.GetAdaptiveGroupPanel()) {
   if(this.grid.rtl)
    left += targetElement.offsetWidth;
  } else {
   if(isRightSide) {
    if(info.neighbor)
     left = ASPx.GetAbsoluteX(info.neighbor);
    else
     left += targetElement.offsetWidth;
   }
  }
  var top = ASPx.GetAbsoluteY(targetElement);
  var bottomElement = targetElement;
  var moveToGroup = this.IsGroupingTarget(targetElement);
  if(!moveToGroup && info.targetColumnIndex > -1)
   bottomElement = this.grid.GetHeader(this.GetHeaderLeaf(info.targetColumnIndex, !isRightSide));
  var bottom = ASPx.GetAbsoluteY(bottomElement) + bottomElement.offsetHeight;
  return { top: top, bottom: bottom, left: left, right: left };
 },
 CreateVerticalTargetImagesPosition: function(targetElement, info){
  var left = ASPx.GetAbsoluteX(targetElement);
  var right = left + targetElement.offsetWidth;
  var top = ASPx.GetAbsoluteY(targetElement);
  if(info.side == ASPx.CursorTargetTag.Bottom)
   top += targetElement.offsetHeight;
  return { top: top, bottom: top, left: left, right: right };
 },
 GetChildHeaderElement: function(parentIndex, childIndex, left){
  var grid = this.grid;
  var childColumnIndex = childIndex;
  var currentColumnIndex = childIndex;
  var getNextNeighborHeaderMatrixMethodName = "Get" + (left ? "Left" : "Right") + "Neighbor";
  while(ASPx.IsExists(currentColumnIndex) && this.IsParentColumn(parentIndex, currentColumnIndex)){
   childColumnIndex = currentColumnIndex; 
   currentColumnIndex = grid.GetHeaderMatrix()[getNextNeighborHeaderMatrixMethodName](childColumnIndex);
  }
  return grid.GetHeader(childColumnIndex);
 },
 IsParentColumn: function(parentIndex, columnIndex){
  var index = columnIndex;
  while(index >= 0 && index != parentIndex)
   index = this.grid.GetColumn(index).parentIndex;
  return index >= 0;
 },
 CreateTargetImagesInfo: function(targets, moveToGroup){
  if(moveToGroup)
   return this.CreateGroupPanelTargetImagesInfo(targets);
  var grid = targets.control;
  var targetElement = targets.targetElement;
  var info = {
   targetColumnIndex: grid.getColumnIndex(targetElement.id),
   side: targets.targetTag,
   neighbor: null
  };
  var isAdaptiveHeader = grid.dragHelper.IsAdaptiveHeaderTarget(targetElement);
  if(!isAdaptiveHeader && info.targetColumnIndex < 0)
   return info;
  if(isAdaptiveHeader && targetElement.adaptiveInfo) {
   info.targetColumnIndex = targetElement.adaptiveInfo.brotherIndex;
   if(!targetElement.adaptiveInfo.brotherHasOnlyOneLeaf)
    info.side = targetElement.adaptiveInfo.isLeftLeaf ? ASPx.CursorTargetTag.Left : ASPx.CursorTargetTag.Right;
  }
  var neighborIndex = this.FindHeaderNeighborIndexByHorizontal(info.side, info.targetColumnIndex, isAdaptiveHeader);
  if(neighborIndex == null)
   info = null;
  else if(neighborIndex > -1)
   info.neighbor = grid.GetHeader(neighborIndex);
  return info;
 },
 CreateGroupPanelTargetImagesInfo: function(targets){
  var grid = targets.control;
  var isRightSide = targets.targetTag == ASPx.CursorTargetTag.Right;
  var method = isRightSide ^ grid.rtl ? "nextSibling" : "previousSibling";
  var neighbor = grid.dragHelper.GetGroupNodeNeighbor(targets.targetElement, method);
  if(neighbor && neighbor.id == ASPx.currentDragHelper.obj.id)
   return null;
  return {
   targetColumnIndex: grid.getColumnIndex(targets.targetElement.id),
   side: targets.targetTag,
   neighbor: neighbor
  };
 },
 FindHeaderNeighborIndexByHorizontal: function(side, targetColumnIndex, isAdaptiveHeader){
  if(side == ASPx.CursorTargetTag.Top || side == ASPx.CursorTargetTag.Bottom)
   return targetColumnIndex;
  var grid = this.grid;
  var isRightSide = side == ASPx.CursorTargetTag.Right;
  var matrix =  grid.GetHeaderMatrix();
  var method = isRightSide ^ grid.rtl ? "GetRightNeighbor" : "GetLeftNeighbor";
  var neighborIndex = matrix[method](targetColumnIndex, !isAdaptiveHeader);
  var sourceColumn = grid.getColumnObject(ASPx.currentDragHelper.obj.id);
  if(neighborIndex == sourceColumn.index && !sourceColumn.inCustWindow && !this.IsGroupHeaderTarget(ASPx.currentDragHelper.obj))
   return sourceColumn.parentIndex != grid.GetColumn(targetColumnIndex).parentIndex ? -1 : null;
  if(!isNaN(neighborIndex)){
   if(isAdaptiveHeader && !matrix.IsLeaf(neighborIndex))
    neighborIndex = matrix.GetLeaf(neighborIndex, isRightSide);
  } else
   neighborIndex = -1;
  return neighborIndex;
 },
 GetGroupNodeNeighbor: function(element, method) {
  if(this.IsAdaptiveGroupHeaderTarget(element)) 
   return this.GetAdaptiveGroupNodeNeighbor(element, method);
  return this.GetGroupNodeNeighborCore(element, method, 2);
 },
 GetAdaptiveGroupNodeNeighbor: function(element, method) {   
  var headers = ASPx.GetNodesByPartialClassName(this.grid.GetAdaptiveGroupPanel(), ASPx.GridViewConsts.HeaderCellCssClass);
  var index = ASPx.Data.ArrayIndexOf(headers, element);
  if(index < 0) return null;   
  return method == "nextSibling" ? headers[index + 1] : headers[index - 1];
 },
 GetGroupNodeNeighborCore: function(element, method, distance) {
  var neighbor = element[method];
  if(neighbor && neighbor.nodeType == 1) {
   if(this.IsGroupingTarget(neighbor)) 
    return neighbor;
   if(distance > 1)
    return this.GetGroupNodeNeighborCore(neighbor, method, --distance);
  }
  return null;
 },
 DisplayTargetImages: function(visible, position){
  var downImage = this.grid.GetArrowDragDownImage();
  if(downImage){
   var showImage = visible && position.left == position.right;
   if(showImage) {
    ASPx.SetAbsoluteX(downImage, position.left - downImage.offsetWidth / 2);
    ASPx.SetAbsoluteY(downImage, position.top - downImage.offsetHeight);
   }
   ASPx.SetElementVisibility(downImage, showImage);
  }
  var upImage = this.grid.GetArrowDragUpImage();
  if(upImage){
   var showImage = visible && position.left == position.right;
   if(showImage) {
    ASPx.SetAbsoluteX(upImage, position.left - upImage.offsetWidth / 2);
    ASPx.SetAbsoluteY(upImage, position.bottom);
   }
   ASPx.SetElementVisibility(upImage, showImage);
  }
  var rightImage = this.grid.GetArrowDragRightImage();
  if(rightImage){
   var showImage = visible && position.left != position.right;
   if(showImage) {
    ASPx.SetAbsoluteX(rightImage, position.left - rightImage.offsetWidth);
    ASPx.SetAbsoluteY(rightImage, position.top - rightImage.offsetHeight / 2);
   }
   ASPx.SetElementVisibility(rightImage, showImage);
  }
  var leftImage = this.grid.GetArrowDragLeftImage();
  if(leftImage){
   var showImage = visible && position.left != position.right;
   if(showImage) {
    ASPx.SetAbsoluteX(leftImage, position.right);
    ASPx.SetAbsoluteY(leftImage, position.top - rightImage.offsetHeight / 2);
   }
   ASPx.SetElementVisibility(leftImage, showImage);
  }
 }
});
GridViewDragHelper.Target_GetElementHeight = null;
ASPx.GridViewDragHelper = GridViewDragHelper;
ASPxClientGridBase.SelectStartHandler = function(e) {
 if(ASPx.Evt.GetEventSource(e).tagName.match(/input|select|textarea/i))
  return;
 if(e.ctrlKey || e.shiftKey) {
  ASPx.Selection.Clear();
  ASPx.Evt.PreventEventAndBubble(e);
 }
};
ASPxClientGridBase.SaveActiveElementSettings = function(grid) {
 var element = grid.GetFilterHelper().GetActiveElement();
 grid.GetFilterHelper().ResetActiveElement();
 ASPxClientGridBase.activeElementData = null;
 if (!element || !element.id || element.tagName != "INPUT" || !(ASPx.GetIsParent(grid.GetMainElement(), element) || element.id.indexOf(grid.name + "_") == 0))
  return;  
 ASPxClientGridBase.activeElementData = [ grid.name, element.id, ASPx.Selection.GetInfo(element).endPos ];
 if(typeof(Sys) != "undefined" && typeof(Sys.Application) != "undefined") {
  if(!ASPxClientGridBase.MsAjaxActiveElementHandlerAdded) {
   Sys.Application.add_load(function() { ASPxClientGridBase.RestoreActiveElementSettings(); } );
   ASPxClientGridBase.MsAjaxActiveElementHandlerAdded = true;
  }
 } 
};
ASPxClientGridBase.RestoreActiveElementSettings = function(grid) {
 var data = ASPxClientGridBase.activeElementData;
 if(!data || grid && data[0] != grid.name) return;
 var element = ASPx.GetElementById(data[1]);
 if(element) {
  window.setTimeout(function() {
   element.focus();
   ASPx.Selection.Set(element, data[2], data[2]);
  }, 0);
 }
 ASPxClientGridBase.activeElementData = null;
};
var ASPxClientGridViewCallbackCommand = {
 NextPage: "NEXTPAGE",
 PreviousPage: "PREVPAGE",
 GotoPage: "GOTOPAGE",
 SelectRows: "SELECTROWS",
 SelectRowsKey: "SELECTROWSKEY",
 Selection: "SELECTION",
 FocusedRow: "FOCUSEDROW",
 Group: "GROUP",
 UnGroup: "UNGROUP",
 Sort: "SORT",
 ColumnMove: "COLUMNMOVE",
 CollapseAll: "COLLAPSEALL",
 ExpandAll: "EXPANDALL",
 ExpandRow: "EXPANDROW",
 CollapseRow: "COLLAPSEROW",
 HideAllDetail: "HIDEALLDETAIL",
 ShowAllDetail: "SHOWALLDETAIL",
 ShowDetailRow: "SHOWDETAILROW",
 HideDetailRow: "HIDEDETAILROW",
 PagerOnClick: "PAGERONCLICK",
 ApplyFilter: "APPLYFILTER",
 ApplyColumnFilter: "APPLYCOLUMNFILTER",
 ApplyMultiColumnFilter: "APPLYMULTICOLUMNFILTER",
 ApplyHeaderColumnFilter: "APPLYHEADERCOLUMNFILTER",
 ApplySearchPanelFilter: "APPLYSEARCHPANELFILTER",
 ApplyCustomizationDialogChanges: "APPLYCUSTOMIZATIONDIALOGCHANGES",
 FilterRowMenu: "FILTERROWMENU",
 StartEdit: "STARTEDIT",
 CancelEdit: "CANCELEDIT",
 UpdateEdit: "UPDATEEDIT",
 AddNewRow: "ADDNEWROW",
 DeleteRow: "DELETEROW",
 CustomButton: "CUSTOMBUTTON",
 CustomCallback: "CUSTOMCALLBACK",
 ShowFilterControl: "SHOWFILTERCONTROL",
 CloseFilterControl: "CLOSEFILTERCONTROL",
 SetFilterEnabled: "SETFILTERENABLED",
 Refresh: "REFRESH",
 SelFieldValues: "SELFIELDVALUES",
 RowValues: "ROWVALUES",
 PageRowValues: "PAGEROWVALUES",
 FilterPopup: "FILTERPOPUP",
 ContextMenu: "CONTEXTMENU",
 Toolbar: "TOOLBAR",
 Export: "EXPORT",
 CustomValues: "CUSTOMVALUES"
};
var ASPxClientGridExportFormat = {
 Pdf: "Pdf",
 Docx: "Docx",
 Rtf: "Rtf",
 Csv: "Csv",
 Xls: "Xls",
 Xlsx: "Xlsx"
};
var ASPxClientGridBatchEditStartEditingEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(visibleIndex, focusedColumn, itemValues) {
  this.constructor.prototype.constructor.call(this);
  this.visibleIndex = visibleIndex;
  this.focusedColumn = focusedColumn;
  this.itemValues = ASPx.CloneObject(itemValues);
 }
});
var ASPxClientGridBatchEditEndEditingEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(visibleIndex, itemValues) {
  this.constructor.prototype.constructor.call(this);
  this.visibleIndex = visibleIndex;
  this.itemValues = ASPx.CloneObject(itemValues);
 }
});
var ASPxClientGridBatchEditItemValidatingEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(visibleIndex, validationInfo) {
  this.constructor.prototype.constructor.call(this);
  this.visibleIndex = visibleIndex;
  this.validationInfo = ASPx.CloneObject(validationInfo);
 }
});
var ASPxClientGridBatchEditConfirmShowingEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(requestTriggerID) {
  this.constructor.prototype.constructor.call(this);
  this.requestTriggerID = requestTriggerID;
 }
});
var ASPxClientGridBatchEditTemplateCellFocusedEventArgs = ASPx.CreateClass(ASPxClientEventArgs, {
 constructor: function(column) {
  this.constructor.prototype.constructor.call(this);
  this.column = column;
  this.handled = false;
 }
});
var ASPxClientGridBatchEditClientChangesEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(insertedValues, deletedValues, updatedValues) {
  this.constructor.prototype.constructor.call(this);
  this.insertedValues = insertedValues;
  this.deletedValues = deletedValues;
  this.updatedValues = updatedValues;
 }
});
var ASPxClientGridBatchEditItemInsertingEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(visibleIndex) {
  this.constructor.prototype.constructor.call(this);
  this.visibleIndex = visibleIndex;
 }
});
var ASPxClientGridBatchEditItemDeletingEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(visibleIndex, itemValues) {
  this.constructor.prototype.constructor.call(this);
  this.visibleIndex = visibleIndex;
  this.itemValues = itemValues;
 }
});
var ASPxClientGridFocusedCellChangingEventArgs = ASPx.CreateClass(ASPxClientCancelEventArgs, {
 constructor: function(cellInfo) {
  this.constructor.prototype.constructor.call(this);
  this.cellInfo = cellInfo;
 }
});
var ASPxClientGridBatchEditApi = ASPx.CreateClass(ASPx.BatchEditApi, {
 constructor: function(owner) {
  this.constructor.prototype.constructor.call(this, owner);
  this.grid = owner;
 },
 GetColumnIndex: function(column) { return this.grid._getColumnIndexByColumnArgs(column); },
 ConvertVisibleIndexToKey: function(visibleIndex) { return this.grid.ConvertVisibleIndexToKey(visibleIndex); },
 ConvertKeyToVisibleIndex: function(key) { return this.grid.ConvertKeyToVisibleIndex(key); },
 CreateCellInfo: function(key, column) {
  var visibleIndex = this.grid.ConvertKeyToVisibleIndex(key);
  return this.grid.CreateCellInfo(visibleIndex, column, key);
 },
 SetCellValue: function(visibleIndex, column, value, displayText, cancelCellHighlighting) { 
  return this.SetCellValueByKey(this.ConvertVisibleIndexToKey(visibleIndex), column, value, displayText, cancelCellHighlighting);
 },
 SetCellValueByKey: function(key, column, value, displayText, cancelCellHighlighting) {
  return this.SetCellValueCore(key, column, value, displayText, cancelCellHighlighting);
 },
 GetCellValue: function(visibleIndex, column, initial) { return this.GetCellValueByKey(this.ConvertVisibleIndexToKey(visibleIndex), column, initial); },
 GetCellValueByKey: function(key, column, initial) { return this.GetCellValueCore(key, column, initial); },
 GetCellTextContainer: function(visibleIndex, column) { return this.GetCellTextContainerByKey(this.ConvertVisibleIndexToKey(visibleIndex), column); },
 GetCellTextContainerByKey: function(key, column) { return this.GetCellTextContainerCore(key, column); },
 HasChanges: function(visibleIndex, column) { return this.HasChangesByKey(this.ConvertVisibleIndexToKey(visibleIndex), column); },
 HasChangesByKey: function(key, column) { return this.HasChangesCore(key, column); },
 ResetChanges: function(visibleIndex, columnIndex) { this.ResetChangesByKey(this.ConvertVisibleIndexToKey(visibleIndex), columnIndex); },
 ResetChangesByKey: function(key, columnIndex) { this.ResetChangesCore(key, columnIndex); },
 StartEdit: function(visibleIndex, columnIndex) { this.StartEditByKey(this.ConvertVisibleIndexToKey(visibleIndex), columnIndex); },
 StartEditByKey: function(key, columnIndex) { this.StartEditCore(key, columnIndex); },
 ValidateItem: function(visibleIndex) { return this.ValidateItemByKey(this.ConvertVisibleIndexToKey(visibleIndex)); },
 ValidateItemByKey: function(key) { return this.ValidateRecordCore(key); },
 IsDeletedItem: function(visibleIndex) { return this.IsDeletedItemByKey(this.ConvertVisibleIndexToKey(visibleIndex)); },
 IsDeletedItemByKey: function(key) { return this.IsDeletedRecordCore(key); },
 IsNewItem: function(visibleIndex) { return this.IsNewRecordCore(this.ConvertVisibleIndexToKey(visibleIndex)); },
 AddNewItem: function() { this.AddNewRecordCore(); }, 
 DeleteItem: function(visibleIndex) { this.DeleteItemByKey(this.ConvertVisibleIndexToKey(visibleIndex)); },
 DeleteItemByKey: function(key) { this.DeleteRecordCore(key); },
 RecoverItem: function(visibleIndex) { this.RecoverItemByKey(this.ConvertVisibleIndexToKey(visibleIndex)); },
 RecoverItemByKey: function(key) { this.RecoverRecordCore(key); },
 GetItemVisibleIndices: function(includeDeleted) { 
  var currentPageKeys = this.FilterCurrentPageKeys(this.GetRecordKeys(includeDeleted));
  return currentPageKeys.map(function(key) { return this.ConvertKeyToVisibleIndex(key); }.bind(this)); 
 },
 GetInsertedItemVisibleIndices: function() { return this.FilterCurrentPageKeys(this.GetInsertedRecordKeys()); },
 GetDeletedItemVisibleIndices: function() {
  var deletedIndices = [];
  var currentPageDeletedKeys = this.FilterCurrentPageKeys(this.GetDeletedRecordKeys());
  ASPx.Data.ForEach(currentPageDeletedKeys, function(key){  
   var visibleIndex = this.ConvertKeyToVisibleIndex(key);
   if(visibleIndex > -1) deletedIndices.push(visibleIndex);
  }.aspxBind(this));
  return deletedIndices;
 },
 GetUpdatedItemVisibleIndices: function() { 
  var keys = this.FilterCurrentPageKeys(this.GetUpdatedRecordKeys());
  return keys.map(function(key) { return this.ConvertKeyToVisibleIndex(key); }.bind(this));
 },
 IsCurrentPageRecord: function(key) {
  var helper = this.GetHelper();
  return !!helper && helper.IsCurrentPageRecord(key);
 },
 FilterCurrentPageKeys: function(keys) { return keys.filter(function (key) { return this.IsCurrentPageRecord(key); }.bind(this)); }
});
var ASPxClientGridCellInfo = ASPx.CreateClass(null, {
 constructor: function(itemIndex, column) {
  this.itemVisibleIndex = itemIndex;
  this.column = column;
 }
});
var ASPxClientGridToolbarItemClickEventArgs = ASPx.CreateClass(ASPxClientProcessingModeEventArgs, {
 constructor: function(toolbarIndex, toolbarName, item, processOnServer) {
  this.constructor.prototype.constructor.call(this, processOnServer);
  this.toolbarIndex = toolbarIndex;
  this.toolbarName = toolbarName;
  this.item = item;
  this.usePostBack = false;
 }
});
ASPxClientGridBase.PostponeInitialize = function(name, info){
 var grid = ASPx.GetControlCollection().Get(name);
 if(grid) {
  grid.styleInfo = info.styleInfo;
  grid.cButtonIDs = info.commandButtonIDs;
  if(grid.batchEditClientState) {
   grid.batchEditClientState.extraCommandButtonsInfo = info.extraCommandButtonsInfo;
  }
  grid.EnsureRowKeys();
  grid.UpdateItemsStyle();
 }
};
ASPx.GHeaderMouseDown = function(name, element, e) {
 var grid = ASPx.GetControlCollection().Get(name);
 if(grid != null) 
  grid.HeaderMouseDown(element, e);
};
ASPx.GSort = function(name, columnIndex) {
 var grid = ASPx.GetControlCollection().Get(name);
 if(grid != null)  
  grid.SortBy(columnIndex);
};
ASPx.GVPopupEditFormOnInit = function(name, popup) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  window.setTimeout(function() { gv.OnPopupEditFormInit(popup); }, 0);
};
ASPx.GVPagerOnClick = function(name, value) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) 
  gv.doPagerOnClick(value);
};
ASPx.GVFilterKeyPress = function(name, element, e) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) 
  gv.GetFilterHelper().OnColumnFilterInputKeyPress(element, e);
};
ASPx.GVFilterSpecKeyPress = function(name, element, e) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) 
  gv.GetFilterHelper().OnColumnFilterInputSpecKeyPress(element, e);
};
ASPx.GVFilterChanged = function(name, element) {
 window.setTimeout(function() {
  var gv = ASPx.GetControlCollection().Get(name);
  var el = ASPx.GetControlCollection().Get(element.name);
  if(gv != null && el != null) 
   gv.GetFilterHelper().OnColumnFilterInputChanged(el);
 }, 0);
};
ASPx.GVFilterUserInput = function(name, element) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.GetFilterHelper().OnColumnFilterUserInput(element);
};
ASPx.GVShowParentRows = function(name, evt, element) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  if(element)
   gv.OnParentRowMouseEnter(element);  
  else 
   gv.OnParentRowMouseLeave(evt);
 }
};
ASPx.GTableClick = function(name, evt) {
 var g = ASPx.GetControlCollection().Get(name);
 if(g != null && g.NeedProcessTableClick(evt))
  g.mainTableClick(evt);
};
ASPx.GVTableDblClick = function(name, evt) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null && gv.NeedProcessTableClick(evt))
  gv.mainTableDblClick(evt);
};
ASPx.GVCustWindowCloseUp = function(name) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  gv.RaiseCustomizationWindowCloseUp();
 }
};
ASPx.GVApplyFilterPopup = function(name) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.ApplyHeaderFilterByColumn();
};
ASPx.GVShowFilterControl = function(name) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  gv.ShowFilterControl();
 }
};
ASPx.GVCloseFilterControl = function(name) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  gv.CloseFilterControl();
 }
};
ASPx.GVSetFilterEnabled = function(name, value) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null) {
  gv.SetFilterEnabled(value);
 }
};
ASPx.GVApplyFilterControl = function(name) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.ApplyFilterControl();
};
ASPx.GVFilterRowMenu = function(name, columnIndex, element) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.GetFilterHelper().FilterRowMenuButtonClick(columnIndex, element);
};
ASPx.GVFilterRowMenuClick = function(name, e) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.GetFilterHelper().FilterRowMenuItemClick(e.item);
};
ASPx.GCmdToolbarMenuItemClick = function(name, toolbar, e) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.GetToolbarHelper().OnToolbarMenuItemClick(toolbar, e);
};
ASPx.GVScheduleCommand = function(name, commandArgs, postponed, event) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.ScheduleUserCommand(commandArgs, postponed, ASPx.Evt.GetEventSource(event));
};
ASPx.GVHFCancelButtonClick = function(name) {
 var gv = ASPx.GetControlCollection().Get(name);
 if(gv != null)
  gv.GetHeaderFilterPopup().Hide();
};
ASPx.GridStyleHelper = GridStyleHelper;
ASPx.GridLayoutHelper = GridLayoutHelper;
ASPx.GridViewDragHelper = GridViewDragHelper;
ASPx.GridCallbackHelper = GridCallbackHelper;
ASPx.GridSortOrder = GridSortOrder;
ASPx.ASPxClientGridExportFormat = ASPxClientGridExportFormat;
window.ASPxClientGridBase = ASPxClientGridBase;
window.ASPxClientGridColumnBase = ASPxClientGridColumnBase;
window.ASPxClientGridViewCallbackCommand = ASPxClientGridViewCallbackCommand;
window.ASPxClientGridBatchEditStartEditingEventArgs = ASPxClientGridBatchEditStartEditingEventArgs;
window.ASPxClientGridBatchEditEndEditingEventArgs = ASPxClientGridBatchEditEndEditingEventArgs;
window.ASPxClientGridBatchEditItemValidatingEventArgs = ASPxClientGridBatchEditItemValidatingEventArgs;
window.ASPxClientGridBatchEditConfirmShowingEventArgs = ASPxClientGridBatchEditConfirmShowingEventArgs;
window.ASPxClientGridBatchEditTemplateCellFocusedEventArgs = ASPxClientGridBatchEditTemplateCellFocusedEventArgs;
window.ASPxClientGridBatchEditClientChangesEventArgs = ASPxClientGridBatchEditClientChangesEventArgs;
window.ASPxClientGridBatchEditItemInsertingEventArgs = ASPxClientGridBatchEditItemInsertingEventArgs;
window.ASPxClientGridBatchEditItemDeletingEventArgs = ASPxClientGridBatchEditItemDeletingEventArgs;
window.ASPxClientGridFocusedCellChangingEventArgs = ASPxClientGridFocusedCellChangingEventArgs;
window.ASPxClientGridBatchEditApi = ASPxClientGridBatchEditApi;
window.ASPxClientGridCellInfo = ASPxClientGridCellInfo;
window.ASPxClientGridColumnMovingTargetPosition = ASPxClientGridColumnMovingTargetPosition;
window.ASPxClientGridToolbarItemClickEventArgs = ASPxClientGridToolbarItemClickEventArgs;
})();

